﻿var DanceVideoDetailCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.videoInfo = {};
            var videoInfo = Cache.getCache("DanceVideoDetail_videoInfo");
            if (videoInfo) {
                that.videoInfo = JSON.parse(videoInfo);
                //FixedStart byzhusj 2016/10/27
                // 显示数据
                $("#danceVideoDetail_title").html(that.videoInfo.VideoName.split("", 12));
                //FixedEnd
                $("#danceVideoDetail_staff").html(that.videoInfo.VideoName);

                // 获取登录信息
                that.loginInfo = Cache.getCache("LoginUserInfo");

                // 获取详细内容
                that.getVideoInfo();

                // 给video添加事件
                that.videoShow = document.getElementById("danceVideoDetail_video");
                that.videoShow.height = window.innerWidth / 5 * 3;

                // 点击事件
                that.videoShow.addEventListener("click", function (obj) {
                    that.videoShow.play();
                });

                // 窗口大小变更
                $(window).resize(function () {
                    that.videoShow.height = window.innerWidth / 5 * 3;
                });
            }

            //教师端隐藏上传
            if (that.loginInfo.UserType == 2)
            {
                $("#danceVideoDetail_button_bar").hide();
            }

            //fixedby lijq 2016/11/15  如果不是ios系统，则添加唤醒进度条的功能
            that.exitFlag = false;// add by lujf 2016-12-1
            if (Util.getSystemType() != "IOS") {
                that.setControl();
            }
            that.init();
        },

        //fixedby lijq 2016/11/15 安卓手机，播放视频时，controllers 进度条一直显示
        setControl: function () {
            var video = document.getElementById("danceVideoDetail_video");
            video.controls = false;
            setTimeout(function () {
                // fixed by lujf 2016-12-1 判断是否退出页面
                if (!that.exitFlag) {
                    that.setControl();
                }
            }, 10);
        },

        // 获取详细内容
        getVideoInfo: function () {
            Util.ajax({
                method: "POST",
                data: {
                    userId: that.loginInfo.UserId,
                    videoId: that.videoInfo.VideoId,
                    userType: that.loginInfo.UserType
                },
                url: Util.getApiUrl("GetVideoDetail")
            }, function (data) {
                that.videoInfo = data;
                // 初始化页面
                that.initLoad();
            });
        },

        // 切换速度
        videoSpeedClick: function (e) {
            var winWidth = window.innerWidth;// 屏幕宽度
            var backWidth = e.currentTarget.clientWidth;// 图片宽度
            var clickPosition = e.touches[0].clientX;//点击位置
            var clientkey = (clickPosition - (winWidth - backWidth) / 2) / (backWidth / 3);

            // 判断视频能否播放
            var imgUrl = document.getElementById("danceVideoDetail_speed_back_img").src;
            var count = 0;
            if (clientkey < 1) {
                count = 0;
            } else if (clientkey <= 2) {
                count = 1;
            } else {
                count = 2;
            }
            if (!that.checkClick(count, imgUrl)) {
                Util.info("视频不可播放！", false);
                return;
            };

            if (clientkey < 1) {//speedDiv
                document.getElementById("danceVideoDetail_speed_block").style.left = "5%";
                document.getElementById("danceVideoDetail_speed").style.left = "5%";
                that.videospeed = enumKey.VideoSpeed.Fast;
            } else if (clientkey <= 2) {
                document.getElementById("danceVideoDetail_speed_block").style.left = "35%";
                document.getElementById("danceVideoDetail_speed").style.left = "35%";
                that.videospeed = enumKey.VideoSpeed.Normal;
            } else {
                document.getElementById("danceVideoDetail_speed_block").style.left = "65%";
                document.getElementById("danceVideoDetail_speed").style.left = "65%";
                that.videospeed = enumKey.VideoSpeed.Slow;
            }
            setTimeout(function () {
                if (clientkey < 1) {//speedDiv
                    document.getElementById("danceVideoDetail_speed").innerHTML = "男步";
                } else if (clientkey <= 2) {
                    document.getElementById("danceVideoDetail_speed").innerHTML = "女步";
                } else {
                    document.getElementById("danceVideoDetail_speed").innerHTML = "双人步";
                }
            }, 250);
            that.secondImg();
            that.playVideo();
        },

        // 切换位置
        videoPlaceClick: function (e) {
            var winWidth = window.innerWidth;// 屏幕宽度
            var backWidth = e.currentTarget.clientWidth;// 图片宽度
            var clickPosition = e.touches[0].clientX;//点击位置
            var clientkey = (clickPosition - (winWidth - backWidth) / 2) / (backWidth / 3);

            // 判断视频能否播放
            var imgUrl = document.getElementById("danceVideoDetail_place_back_img").src;
            var count = 0;
            if (clientkey < 1) {
                count = 0;
            } else if (clientkey <= 2) {
                count = 1;
            } else {
                count = 2;
            }
            if (!that.checkClick(count, imgUrl)) {
                Util.info("视频不可播放！", false);
                return;
            };

            if (clientkey < 1) {//speedDiv
                document.getElementById("danceVideoDetail_place_block").style.left = "5%";
                document.getElementById("danceVideoDetail_place").style.left = "5%";
                that.videoPosition = enumKey.VideoPosition.Left;
            } else if (clientkey <= 2) {
                document.getElementById("danceVideoDetail_place_block").style.left = "35%";
                document.getElementById("danceVideoDetail_place").style.left = "35%";
                that.videoPosition = enumKey.VideoPosition.Middle;
            } else {
                document.getElementById("danceVideoDetail_place_block").style.left = "65%";
                document.getElementById("danceVideoDetail_place").style.left = "65%";
                that.videoPosition = enumKey.VideoPosition.Right;
            }
            setTimeout(function () {
                if (clientkey < 1) {//speedDiv
                    document.getElementById("danceVideoDetail_place").innerHTML = "音乐";
                } else if (clientkey <= 2) {
                    document.getElementById("danceVideoDetail_place").innerHTML = "节奏";
                } else {
                    document.getElementById("danceVideoDetail_place").innerHTML = "静音";
                }
            }, 250);
            that.playVideo();
        },

        // 页面初始化数据
        initLoad : function(){
            that.newvideoInfo = new Object();
            for(var key in that.videoInfo){
                if(key == "FastLeft" || key == "FastMiddle"  || key == "FastRight"  || key == "NormalLeft"  
                || key == "NormalMiddle"  || key == "NormalRight"  || key == "SlowLeft"|| key == "SlowMiddle"|| key == "SlowRight"){
                    if(!that.videoInfo[key]){
                        that.newvideoInfo[key] = "0";
                    }else{
                        that.newvideoInfo[key] = "1";
                    }
                }
            }
            //获取第一个有视频的画面
            if (that.videoInfo.FastLeft) {
                that.videospeed = enumKey.VideoSpeed.Fast;
                that.videoPosition = enumKey.VideoPosition.Left;

                document.getElementById("danceVideoDetail_speed_block").style.left = "5%";
                document.getElementById("danceVideoDetail_speed").style.left = "5%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "男步";
                document.getElementById("danceVideoDetail_place_block").style.left = "5%";
                document.getElementById("danceVideoDetail_place").style.left = "5%";
                document.getElementById("danceVideoDetail_place").innerHTML = "音乐";
			
            }else if(that.videoInfo.FastMiddle){
                that.videospeed = enumKey.VideoSpeed.Fast;
                that.videoPosition = enumKey.VideoPosition.Middle;
	        
                document.getElementById("danceVideoDetail_speed_block").style.left = "5%";
                document.getElementById("danceVideoDetail_speed").style.left = "5%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "男步";
                document.getElementById("danceVideoDetail_place_block").style.left = "35%";
                document.getElementById("danceVideoDetail_place").style.left = "35%";
                document.getElementById("danceVideoDetail_place").innerHTML = "节奏";
			
            }else if(that.videoInfo.FastRight){
                that.videospeed = enumKey.VideoSpeed.Fast;
                that.videoPosition = enumKey.VideoPosition.Right;
	        
                document.getElementById("danceVideoDetail_speed_block").style.left = "5%";
                document.getElementById("danceVideoDetail_speed").style.left = "5%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "男步";
                document.getElementById("danceVideoDetail_place_block").style.left = "65%";
                document.getElementById("danceVideoDetail_place").style.left = "65%";
                document.getElementById("danceVideoDetail_place").innerHTML = "静音";
			
            }else if(that.videoInfo.NormalLeft){
                that.videospeed = enumKey.VideoSpeed.Normal;
                that.videoPosition = enumKey.VideoPosition.Left;
	        
                document.getElementById("danceVideoDetail_speed_block").style.left = "35%";
                document.getElementById("danceVideoDetail_speed").style.left = "35%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "女步";
                document.getElementById("danceVideoDetail_place_block").style.left = "5%";
                document.getElementById("danceVideoDetail_place").style.left = "5%";
                document.getElementById("danceVideoDetail_place").innerHTML = "音乐";
			
            }else if(that.videoInfo.NormalMiddle){
                that.videospeed = enumKey.VideoSpeed.Normal;
                that.videoPosition = enumKey.VideoPosition.Middle;
	        
                document.getElementById("danceVideoDetail_speed_block").style.left = "35%";
                document.getElementById("danceVideoDetail_speed").style.left = "35%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "女步";
                document.getElementById("danceVideoDetail_place_block").style.left = "35%";
                document.getElementById("danceVideoDetail_place").style.left = "35%";
                document.getElementById("danceVideoDetail_place").innerHTML = "节奏";
			
            }else if(that.videoInfo.NormalRight){
                that.videospeed = enumKey.VideoSpeed.Normal;
                that.videoPosition = enumKey.VideoPosition.Right;
	         
                document.getElementById("danceVideoDetail_speed_block").style.left = "35%";
                document.getElementById("danceVideoDetail_speed").style.left = "35%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "女步";
                document.getElementById("danceVideoDetail_place_block").style.left = "65%";
                document.getElementById("danceVideoDetail_place").style.left = "65%";
                document.getElementById("danceVideoDetail_place").innerHTML = "静音";
			
            }else if(that.videoInfo.SlowLeft){
                that.videospeed = enumKey.VideoSpeed.Slow;
                that.videoPosition = enumKey.VideoPosition.Left;
	        
                document.getElementById("danceVideoDetail_speed_block").style.left = "65%";
                document.getElementById("danceVideoDetail_speed").style.left = "65%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "双人步";
                document.getElementById("danceVideoDetail_place_block").style.left = "5%";
                document.getElementById("danceVideoDetail_place").style.left = "5%";
                document.getElementById("danceVideoDetail_place").innerHTML = "音乐";
			
            }else if(that.videoInfo.SlowMiddle){
                that.videospeed = enumKey.VideoSpeed.Slow;
                that.videoPosition = enumKey.VideoPosition.Middle;
	        
                document.getElementById("danceVideoDetail_speed_block").style.left = "65%";
                document.getElementById("danceVideoDetail_speed").style.left = "65%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "双人步";
                document.getElementById("danceVideoDetail_place_block").style.left = "35%";
                document.getElementById("danceVideoDetail_place").style.left = "35%";
                document.getElementById("danceVideoDetail_place").innerHTML = "节奏";
			
            }else if(that.videoInfo.SlowRight){
                that.videospeed = enumKey.VideoSpeed.Slow;
                that.videoPosition = enumKey.VideoPosition.Right;

                document.getElementById("danceVideoDetail_speed_block").style.left = "65%";
                document.getElementById("danceVideoDetail_speed").style.left = "65%";
                document.getElementById("danceVideoDetail_speed").innerHTML = "双人步";
                document.getElementById("danceVideoDetail_place_block").style.left = "65%";
                document.getElementById("danceVideoDetail_place").style.left = "65%";
                document.getElementById("danceVideoDetail_place").innerHTML = "静音";
            }else{
            }
            //第一个图片地址
            var url ="1";
            if(that.videoInfo.FastLeft || that.videoInfo.FastMiddle || that.videoInfo.FastRight){
                url += "1";
            }else{
                url += "0";
            }
            if(that.videoInfo.NormalLeft || that.videoInfo.NormalMiddle || that.videoInfo.NormalRight){
                url += "1";
            }else{
                url += "0";
            }
            if(that.videoInfo.SlowLeft || that.videoInfo.SlowMiddle || that.videoInfo.SlowRight){
                url += "1";
            }else{
                url += "0";
            }
            url = "images/learn/dance/" + url + ".png";
            document.getElementById("danceVideoDetail_speed_back_img").src = url;
            that.secondImg();
            that.playVideo();
        },

        // 第二个图片地址
        secondImg : function(){
            var url ="0",flag = false;
            if(that.videospeed == enumKey.VideoSpeed.Fast){
                //第二个图片地址
                if(that.videoInfo.FastLeft){
                    flag = true;
                    that.videoPosition =  enumKey.VideoPosition.Left;
                    url += "1";
                }else{
                    url += "0";
                }
                if(that.videoInfo.FastMiddle){
                    if(!flag){
                        flag = true;
                        that.videoPosition =  enumKey.VideoPosition.Middle;
                    };
                    url += "1";
                }else{
                    url += "0";
                }
                if(that.videoInfo.FastRight){
                    if(!flag){
                        flag = true;that.videoPosition =  enumKey.VideoPosition.Right;
                    };
                    url += "1";
                }else{
                    url += "0";
                }
                url = "images/learn/dance/" + url + ".png";
                document.getElementById("danceVideoDetail_place_back_img").src=url;
            }else if(that.videospeed == enumKey.VideoSpeed.Normal){
                if(that.videoInfo.NormalLeft){
                    flag = true;
                    that.videoPosition =  enumKey.VideoPosition.Left;
                    url += "1";
                }else{
                    url += "0";
                }
                if(that.videoInfo.NormalMiddle){
                    if(!flag){flag = true;that.videoPosition =  enumKey.VideoPosition.Middle};
                    url += "1";
                }else{
                    url += "0";
                }
                if(that.videoInfo.NormalRight){
                    if(!flag){flag = true;that.videoPosition =  enumKey.VideoPosition.Right};
                    url += "1";
                }else{
                    url += "0";
                }
                url = "images/learn/dance/" + url + ".png";
                document.getElementById("danceVideoDetail_place_back_img").src=url;
            }else{
                if(that.videoInfo.SlowLeft){
                    flag = true;
                    that.videoPosition =  enumKey.VideoPosition.Left;
                    url += "1";
                }else{
                    url += "0";
                }
                if(that.videoInfo.SlowMiddle){
                    if(!flag){flag = true;that.videoPosition =  enumKey.VideoPosition.Middle};
                    url += "1";
                }else{
                    url += "0";
                }
                if(that.videoInfo.SlowRight){
                    if(!flag){flag = true;that.videoPosition =  enumKey.VideoPosition.Right};
                    url += "1";
                }else{
                    url += "0";
                }
                url = "images/learn/dance/" + url + ".png";
                document.getElementById("danceVideoDetail_place_back_img").src=url;
	    	
            }
	    
            if(that.videoPosition == enumKey.VideoPosition.Left){//speedDiv
                document.getElementById("danceVideoDetail_place_block").style.left = "5%";
                document.getElementById("danceVideoDetail_place").style.left = "5%";
			
            }else if(that.videoPosition == enumKey.VideoPosition.Middle){
                document.getElementById("danceVideoDetail_place_block").style.left = "35%";
                document.getElementById("danceVideoDetail_place").style.left = "35%";
            }else{
                document.getElementById("danceVideoDetail_place_block").style.left = "65%";
                document.getElementById("danceVideoDetail_place").style.left = "65%";
            }
            setTimeout(function(){
                if(that.videoPosition == enumKey.VideoPosition.Left){//speedDiv
                    document.getElementById("danceVideoDetail_place").innerHTML = "音乐";
                }else if(that.videoPosition == enumKey.VideoPosition.Middle){
                    document.getElementById("danceVideoDetail_place").innerHTML = "节奏";
                }else{
                    document.getElementById("danceVideoDetail_place").innerHTML = "静音";
                }
            },250);
        },

        // 播放视频
        playVideo : function(){
            if(that.videospeed == enumKey.VideoSpeed.Fast){
                if(that.videoPosition == enumKey.VideoPosition.Left){
                    document.getElementById("danceVideoDetail_video").src = that.videoInfo.FastLeftInfo;
                }else if(that.videoPosition == enumKey.VideoPosition.Middle){
                    document.getElementById("danceVideoDetail_video").src = that.videoInfo.FastMiddleInfo;
                }else{
                    document.getElementById("danceVideoDetail_video").src = that.videoInfo.FastRightInfo;
                }
            }else if(that.videospeed == enumKey.VideoSpeed.Normal){
                if(that.videoPosition == enumKey.VideoPosition.Left){
                    document.getElementById("danceVideoDetail_video").src = that.videoInfo.NormalLeftInfo;
                }else if(that.videoPosition == enumKey.VideoPosition.Middle){
                    document.getElementById("danceVideoDetail_video").src = that.videoInfo.NormalMiddleInfo;
                }else{
                    document.getElementById("danceVideoDetail_video").src =that.videoInfo.NormalRightInfo;
                }
            }else{
                if(that.videoPosition == enumKey.VideoPosition.Left){
                    document.getElementById("danceVideoDetail_video").src =that.videoInfo.SlowLeftInfo;
                }else if(that.videoPosition == enumKey.VideoPosition.Middle){
                    document.getElementById("danceVideoDetail_video").src = that.videoInfo.SlowMiddleInfo;
                }else{
                    document.getElementById("danceVideoDetail_video").src = that.videoInfo.SlowRightInfo;
                }
            }
        },

        // 判断视频能否播放
        checkClick : function(count,imgurl){
            var result = false;
            var spstr = imgurl.split(".")[imgurl.split(".").length-2];;
            var imgarr = spstr.substring(spstr.length-3,spstr.length);
            if(imgarr[count] == "1"){
                return true;
            }else{
                return false;
            }    
        },

        // 上传作业
        uploadHomework: function () {
            // fixed by lujf 2016-11-23 记录上传作业路径
            var videoInfo = Cache.getCache("DanceVideoDetail_videoInfo");
            $("#danceVideoDetail_video")[0].pause();
            
            //todo 传参数到上传作业页面 showHomeworkPop(videoInfo);
            toUploadVideo(JSON.parse(videoInfo), function (value) {
                if (value) {
                    that.exitFlag = true;// add by lujf 2016-12-01 设置是否退出页面标记
                }
            });
        },

        //本页面返回，暂停播放
        myBack: function () {
            that.exitFlag = true;// add by lujf 2016-12-01 设置是否退出页面标记
            videoPageBack("danceVideoDetail_video");
            that.refreshControls();
        },

        //自定义video控制条
        init: function () {
            that.timeDrag = false;
            that.isFullScreen = false;
            var playImgSrc = "images/homeworkTe/play.png";
            var pauseImgSrc = "images/homeworkTe/pause.png";
            var fullscreenImgSrc = "images/homeworkTe/fullscreen.png";
            var cancelFullscreenImgSrc = "images/homeworkTe/cancelFullscreen.png";
            var myVideo = document.getElementById("danceVideoDetail_video");
            // 监听播放/暂停点击事件
            if (!that.checkBindEnvent($('.danceVideoDetail_play_btn'), 'click')) {
                $('.danceVideoDetail_play_btn').on('click', function () {
                    if (myVideo.paused) {
                        $(".danceVideoDetail_play_btn img").attr("src", pauseImgSrc);
                        myVideo.play();
                    }
                    else {
                        $(".danceVideoDetail_play_btn img").attr("src", playImgSrc);
                        myVideo.pause();
                    }
                });
            }

            //get HTML5 video time duration 获取video的总时间
            if (!that.checkBindEnvent($("#danceVideoDetail_video"), 'loadedmetadata')) {
                $("#danceVideoDetail_video").on('loadedmetadata', function () {
                    $('.danceVideoDetail_duration').text(Util.formatTimeSpan(myVideo.duration));
                });
            }

            //update HTML5 video current play time 获取video当前时间
            if (!that.checkBindEnvent($("#danceVideoDetail_video"), 'timeupdate')) {
                $("#danceVideoDetail_video").on('timeupdate', function () {
                    $('.danceVideoDetail_current').text(Util.formatTimeSpan(myVideo.currentTime));
                    var currentPos = myVideo.currentTime; //Get currenttime
                    var maxduration = myVideo.duration; //Get video duration
                    var percentage = 100 * currentPos / maxduration; //in %
                    $('.danceVideoDetail_timeBar').css('width', percentage + '%');
                });
            }

            // 监听全屏事件
            if (!that.checkBindEnvent($('.danceVideoDetail_fullscreen_btn'), 'click')) {
                $('.danceVideoDetail_fullscreen_btn').on('click', function () {
                    // 如果是全屏的状态
                    if (that.isFullScreen) {
                        that.refreshControls();
                        that.isFullScreen = false;
                    } else {// 如果是非全屏状态
                        $(".danceVideoDetail_fullscreen_btn img").attr("src", cancelFullscreenImgSrc);
                        $(".danceVideoDetail_video_div").addClass("danceVideoDetail_video_div_full");
                        $("#danceVideoDetail_video").addClass("danceVideoDetail_video_div_video_full");
                        $(".danceVideoDetail_showVideo video").css("height", "100%");
                        $(".danceVideoDetail_showVideo").css("height", "100%");
                        $(".danceVideoDetail_button_bar").css("display", "none");
                        that.isFullScreen = true;
                    }
                });
            }

            //进度条
            if (!that.checkBindEnvent($('.danceVideoDetail_progressBar'), 'touchstart')) {
                $('.danceVideoDetail_progressBar').on('touchstart', function (e) {
                    that.timeDrag = true;
                    that.updateBar(e.touches[0].pageX);
                });
            }
            if (!that.checkBindEnvent($('.danceVideoDetail_progressBar'), 'touchend')) {
                $('.danceVideoDetail_progressBar').on('touchend', function (e) {
                    if (that.timeDrag) {
                        that.timeDrag = false;
                    }
                });
            }
            if (!that.checkBindEnvent($('.danceVideoDetail_progressBar'), 'touchmove')) {
                $('.danceVideoDetail_progressBar').on('touchmove', function (e) {
                    if (that.timeDrag) {
                        that.updateBar(e.touches[0].pageX);
                    }
                });
            }
        },
        //查看某个元素是否绑定了某个事件
        checkBindEnvent: function (selector, eventName) {
            //jQuery event封装支持判断元素上是否绑定了事件，此方法只适用于jQuery绑定的事件
            var $events = $._data(selector[0], "events");
            if ($events && $events[eventName]) {
                return true;
            }
            return false;
        },

        //更新进度条
        updateBar: function (x) {
            var myVideo = document.getElementById("danceVideoDetail_video");
            var progress = $('.danceVideoDetail_progressBar');
            var maxduration = myVideo.duration; //Video duraiton
            var position = x - progress.offset().left; //Click pos
            var percentage = 100 * position / progress.width();

            //Check within range
            if (percentage > 100) {
                percentage = 100;
            }
            if (percentage < 0) {
                percentage = 0;
            }

            //Update progress bar and video currenttime
            $('.danceVideoDetail_timeBar').css('width', percentage + '%');
            myVideo.currentTime = maxduration * percentage / 100;
        },

        //还原初始状态
        refreshControls: function () {
            $(".danceVideoDetail_fullscreen_btn img").attr("src", "images/homeworkTe/fullscreen.png");
            $(".danceVideoDetail_video_div").removeClass("danceVideoDetail_video_div_full");
            $("#danceVideoDetail_video").removeClass("danceVideoDetail_video_div_video_full");
            $(".danceVideoDetail_showVideo video").css("height", "");
            $(".danceVideoDetail_showVideo").css("height", "");
            $(".danceVideoDetail_button_bar").css("display", "block");
        }
    };
    return new obj();
})();