﻿var AreaCityCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.pageshow = 0;
            $("#city").css("-webkit-transform", "translate(100%,0)");
            $("#city").css("transition", "initial");
            $("#area").css("-webkit-transform", "translate(100%,0)");
            $("#area").css("transition", "initial");
            that.getDataByUrl("js/data.json", function (data) {
                that.provincelist = new Array();
                for (var i = 0; i < 26; i++) {
                    that.provincelist[i] = new Array();
                    var j = 0;
                    for (var k = 0; k < data.length; k++) {
                        if (data[k].firstChar == String.fromCharCode(65 + i)) {
                            that.provincelist[i][j] = data[k];
                            j = j + 1;
                        }
                        else {
                            null;
                        }
                    };
                };
                that.loadList();
                that.provinceScroller = new devAfScroller("province", { refresh: false });
                that.cityScroller = new devAfScroller("city", { refresh: false });
                that.areaScroller = new devAfScroller("area", { refresh: false });
            });
        },

        updateArea: function (num, num2, a, b) {
            that.myplace = that.provincelist[num][num2].name + "-" + that.provincelist[num][num2].child[a].name + "-" + that.provincelist[num][num2].child[a].child[b].name;
            Util.popConfirm("确认", "您选择的是 " + that.myplace, function (result) {
                if (result) {
                    that.ModifyAddress();
                }           
            }, false);
        },

        ModifyAddress: function () {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            Util.ajax({
                method: "POST",
                data: {
                    areaId:that.LoginUser.AreaId,
                    areaInfo: that.myplace,
                    userId:that.LoginUser.UserId,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("ModifyAddress")
            }, function (data) {
                if (data.ResponseCode == 1) {
                    that.LoginUser.AreaInfo = that.myplace;
                    Cache.setCache("LoginUserInfo", that.LoginUser);
                    Util.info(data.ResponseMessage, true);
                    //toPage('pnl_personalData');
                    $.ui.goBack();
                }
                else {
                    Util.info(data.ResponseMessage, false);
                }
            });
        },

        //获取省市列表并填充页面
        getDataByUrl: function (data, callback) {
            var province_this = this;
            $.ajax({
                dataType: 'json',
                cache: true,
                url: data,
                type: 'GET',
                success: function (result) {
                    province_this.data = result.data;
                    if (typeof callback == 'function') {
                        callback(result.data);
                    }
                },
                accepts: {
                    json: "application/json, text/javascript, */*; q=0.01"
                }
            });
        },


        //城市页面滑动切换
        changeCity: function () {
            $("#city").css("-webkit-transform", "translate(-100%,0)");
            $("#city").css("transition", "500ms");
        },

        //区页面滑动切换
        changeArea: function () {
            $("#area").css("-webkit-transform", "translate(-100%,0)");
            $("#area").css("transition", "500ms");
        },

        //城市滑动页面还原
        cityGoback: function () {
            if (that.pageshow == 0) {
                $("#city").css("-webkit-transform", "translate(100%,0)");
                $("#city").css("transition", "500ms");
                that.pageshow = 1;
                $("#province_name" + that.number + that.number2 + "").css("background-color", "white");
            } else {
                $("#city").css("-webkit-transform", "translate(100%,0)");
                $("#city").css("transition", "500ms");
            }
        },

        //区滑动页面还原
        areaGoback: function () {
            if (that.pageshow == 1) {
                $("#area").css("-webkit-transform", "translate(100%,0)");
                $("#area").css("transition", "500ms");
                that.pageshow = 0;
                $("#province_name" + that.number + that.number2 + "").css("background-color", "white");
            } else {
                return;
            }
        },

        //将省份列表填充页面
        loadList: function () {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            if (that.LoginUser.AreaInfo == null) {
                document.getElementById("province_location").innerHTML = "当前：" ;
            }
            else {
                document.getElementById("province_location").innerHTML = "当前：" + that.LoginUser.AreaInfo;
            }                        
            document.getElementById("province_list_body").innerHTML = "";
            for (var i = 0; i < 26; i++) {
                if (that.provincelist[i].length == 0) {
                    null;
                } else {
                    var item = document.createElement("div");
                    item.className = "province_whitearea";
                    var charhead = document.createElement("div");
                    charhead.className = "province_charhead";
                    charhead.innerHTML = that.provincelist[i][0].firstChar;
                    var cityplace = document.createElement("div");
                    cityplace.className = "province_cityplace";
                }
                for (var j = 0; j < that.provincelist[i].length; j++) {
                    var whitearea = document.createElement("div");
                    whitearea.className = "province_list";
                    whitearea.id = "province_name" + i + j;
                    (function (targetEle, index, index2) {
                        targetEle.onclick = function () {
                            if (that.number == index && that.number2 == index2) {
                                $(".province_list").css("background-color", "");
                                $("#city").css("-webkit-transform", "translate(100%,0)");
                                $("#city").css("transition", "500ms");
                                that.pageshow = 0;
                                that.number = -1;
                                that.number2 = -1;
                            }
                            else {
                                that.loadCity(index, index2);
                                that.choosestyle(index, index2);
                            }
                        };
                    })(whitearea, i, j);
                    var provinceName = document.createElement("div");
                    provinceName.className = "province_name";
                    provinceName.innerHTML = that.provincelist[i][j].name;
                    var goto = document.createElement("div");
                    goto.className = "province_img";
                    goto.innerHTML = '<img src="images/person/data_goto.png" style="height:15px;" />';
                    item.appendChild(charhead);
                    item.appendChild(cityplace);
                    cityplace.appendChild(whitearea);
                    whitearea.appendChild(provinceName);
                    whitearea.appendChild(goto);
                    document.getElementById("province_list_body").appendChild(item);
                }
            }      
        },

        //省份选中样式
        choosestyle: function (anum, bnum) {
            $(".province_list").css("background-color", "");
            $("#province_name" + anum + bnum + "").css("background-color", "#ECECEC");
            that.number = anum;
            that.number2 = bnum;
        },

        //将城市列表填充页面
        loadCity: function (num, num2) {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            if (that.LoginUser.AreaInfo == null) {
                document.getElementById("city_location").innerHTML = "当前：";
            }
            else {
                document.getElementById("city_location").innerHTML = "当前：" + that.LoginUser.AreaInfo;
            }
            that.pageshow = 1;
            document.getElementById("city_list_body").innerHTML = "";
            for (var a = 0; a < that.provincelist[num][num2].child.length; a++) {
                var item = document.createElement("div");
                item.className = "province_list";
                (function (targetEle, index, index2, index3) {
                    targetEle.onclick = function () {
                        if (that.number == index && that.number2 == index2) {
                            $(".province_list").css("background-color", "");
                            $("#area").css("-webkit-transform", "translate(100%,0)");
                            $("#area").css("transition", "500ms");
                            that.pageshow = 0;
                            that.number = -1;
                            that.number2 = -1;
                        }
                        else {
                            that.loadArea(index, index2, index3);
                            that.choosestyle(index, index2);
                        }
                    };
                })(item, num, num2, a);
                var cityName = document.createElement("div");
                cityName.className = "province_name";
                cityName.innerHTML = that.provincelist[num][num2].child[a].name;
                item.appendChild(cityName);
                var goto = document.createElement("div");
                goto.className = "province_img";
                goto.innerHTML = '<img src="images/person/data_goto.png" style="height:15px;" />';
                item.appendChild(goto);
                document.getElementById("city_list_body").appendChild(item);
                that.changeCity();
            }

        },

        //将区列表填充页面
        loadArea: function (num, num2, a) {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            if (that.LoginUser.AreaInfo == null) {
                document.getElementById("area_location").innerHTML = "当前：";
            }
            else {
                document.getElementById("area_location").innerHTML = "当前：" + that.LoginUser.AreaInfo;
            }
            that.pageshow = 1;
            document.getElementById("area_list_body").innerHTML = "";
            for (var b = 0; b < that.provincelist[num][num2].child[a].child.length; b++) {
                var item = document.createElement("div");
                item.className = "province_list";
                var areaName = document.createElement("div");
                areaName.className = "province_name";
                areaName.innerHTML = that.provincelist[num][num2].child[a].child[b].name;
                item.appendChild(areaName);
                document.getElementById("area_list_body").appendChild(item);
                (function (targetEle, index, index2, index3, index4) {
                    targetEle.onclick = function () {
                        that.updateArea(index, index2, index3, index4);
                    };
                })(item, num, num2, a, b);
                that.changeArea();
            }
        },
    };
    return new obj();
})();