﻿//*******作者 zhoucx 2016-07-05 v1.0.0********//
var Actionsheet = function (parentEleId, buttonArray, options) {
    var that = this;
    //父容器
    that.parentEle = (parentEleId && document.getElementById(parentEleId)) ? document.getElementById(parentEleId) : document.body;
    //按钮一览
    that.buttonArray = buttonArray ? buttonArray : [{ text: "关闭", cssName: "", onclick: that.close }];
    //背景阴影
    that.shadow = document.createElement("div");
    that.shadow.className = "dev_actionsheet_shadow";
    that.shadow.addEventListener("click", function () { that.close() });
    //创建actionsheet
    that.asPanel = document.createElement("div");
    that.asPanel.className = "dev_actionsheet_panel";
    that.asPanel.style.bottom = -(15 * that.buttonArray.length + 2) + "vw";
    for (var i = 0; i < that.buttonArray.length; i++) {
        var btn = document.createElement("div");
        btn.classList.add("dev_actionsheet_item");
        if (that.buttonArray[i].styleList) {
            var stList = that.buttonArray[i].styleList.split(";");
            for (var j = 0; j < stList.length; j++) {
                if (!stList[j].trim()) {
                    continue;
                }
                var st = stList[j].split(":");
                if (!st || st.length != 2) {
                    continue;
                }
                $(btn).css(st[0], st[1]);
            }
        }
        if (that.buttonArray[i].cssName) {
            btn.classList.add(that.buttonArray[i].cssName);
        }
        btn.innerHTML = that.buttonArray[i].text;
        if (typeof that.buttonArray[i].onclick == 'function') {
            btn.addEventListener("click", that.buttonArray[i].onclick);
        }
        that.asPanel.appendChild(btn);
    }
    //打开actionsheet
    that.show = function () {
        that.parentEle.appendChild(that.shadow);
        that.parentEle.appendChild(that.asPanel);
        setTimeout(function () {
            that.shadow.style.display = "block";
            that.asPanel.style.webkitTransform = "translate(0," + that.asPanel.style.bottom + ")";
            //控制安卓返回键
            Cache.setCache("GoBackFunction", that.close);
        }, 5);
    };
    //关闭actionsheet
    that.close = function () {
        that.shadow.style.display = "none";
        that.asPanel.style.webkitTransform = "initial";
        setTimeout(that.Dispose, 500);
        //控制安卓返回键
        Cache.clearCache("GoBackFunction");
    };
    //释放插件
    that.Dispose = function () {
        that.parentEle.removeChild(that.shadow);
        that.parentEle.removeChild(that.asPanel);
    };
}