﻿//*******作者 zhoucx 2016-06-22 v1.0.0********//
var ListScroller = function (listEleId, options) {
    var that = this;
    //此值决定y轴上/下滚动多少像素释放时触发事件
    that.eventTriggerY = options.eventTriggerY ? options.eventTriggerY : 40;
    //顶部提示语框
    that.topPromptElement = options.topPromptElement ? document.getElementById(options.topPromptElement) : document.createElement("div");
    //底部提示语框
    that.bottomPromptElement = options.bottomPromptElement ? document.getElementById(options.bottomPromptElement) : document.createElement("div");
    //下拉释放事件
    that.onPullDownRelease = options.onPullDownRelease ? options.onPullDownRelease : function () { that.pullback(); };
    //上拉释放事件
    that.onPullUpRelease = options.onPullUpRelease ? options.onPullUpRelease : function () { that.pullback(); };
    //本次点击起始Y
    var touchStartY = 0;
    var movingY = 0;
    var nowTransform = 0;
    var targetList = document.getElementById(listEleId);
    that.topPromptElement.innerHTML = "下拉刷新";
    that.bottomPromptElement.innerHTML = "上拉加载";
    targetList.addEventListener("touchstart", function (e) {
        targetList.style.transitionDuration = "initial";
        touchStartY = e.touches[0].pageY;
        movingY = touchStartY;
    });
    targetList.addEventListener("touchend", function (e) {
        var yDiff = movingY - touchStartY;
        nowTransform = nowTransform + yDiff;
        if (nowTransform > 0) {
            if (nowTransform < that.eventTriggerY) {
                that.topPromptElement.innerHTML = "下拉刷新";
                that.pullback();
            }
            else {
                nowTransform = that.eventTriggerY;
                targetList.style.transitionDuration = "300ms";
                targetList.style.webkitTransform = "translate(0," + nowTransform + "px)";
                that.topPromptElement.innerHTML = "刷新中";
                that.onPullDownRelease();
            }
        }
        else if (that.hasMoreRecord == true) {
            //判断是否滑到底
            var parentEle = targetList.parentElement;
            //未撑出父元素区域
            if (parseFloat(parentEle.offsetHeight) > parseFloat(targetList.offsetHeight)
                - parseFloat(that.bottomPromptElement.offsetHeight)) {
                if (-nowTransform < that.eventTriggerY) {
                    that.bottomPromptElement.innerHTML = "上拉加载";
                    that.pullback();
                }
                else {
                    targetList.style.transitionDuration = "300ms";
                    targetList.style.webkitTransform = "initial";
                    nowTransform = 0;
                    that.bottomPromptElement.innerHTML = "加载中";
                    that.onPullUpRelease();
                }
            }
            else if (parseFloat(parentEle.offsetHeight) - nowTransform >= parseFloat(targetList.offsetHeight)) {
                targetList.style.transitionDuration = "300ms";
                nowTransform = parseFloat(parentEle.offsetHeight) - parseFloat(targetList.offsetHeight);
                targetList.style.webkitTransform = "translate(0," + nowTransform + "px)";
                that.bottomPromptElement.innerHTML = "加载中";
                that.onPullUpRelease();
            }
            else if (parseFloat(parentEle.offsetHeight) - nowTransform >=
                parseFloat(targetList.offsetHeight) - parseFloat(that.bottomPromptElement.offsetHeight)) {
                that.bottomPromptElement.innerHTML = "上拉加载";
                that.pullback();
            }
        }
        else {
            //无更多数据时直接回弹
            that.pullback();
        }
    });
    targetList.addEventListener("touchmove", function (e) {
        var yDiff = e.touches[0].pageY - touchStartY;
        targetList.style.webkitTransform = "translate(0," + (nowTransform + yDiff) + "px)";
        movingY = e.touches[0].pageY;
        if (yDiff > 0) {
            if (yDiff < that.eventTriggerY) {
                that.topPromptElement.innerHTML = "下拉刷新";
            }
            else {
                that.topPromptElement.innerHTML = "释放刷新";
            }
        }
        else {
            if (that.hasMoreRecord == true) {
                if (-yDiff < that.eventTriggerY) {
                    that.bottomPromptElement.innerHTML = "上拉加载";
                }
                else {
                    that.bottomPromptElement.innerHTML = "释放加载";
                }
            }
        }
    });
    //位置回归
    that.pullback = function () {
        var parentEle = targetList.parentElement;
        //未撑出父元素区域，直接回弹至顶部
        if (parseFloat(parentEle.offsetHeight) > parseFloat(targetList.offsetHeight)
            - parseFloat(that.bottomPromptElement.offsetHeight)) {
            targetList.style.transitionDuration = "300ms";
            nowTransform = 0;
            targetList.style.webkitTransform = "initial";
        }
        //前提判断：是否拉出正文部分
        else if (nowTransform < 0 && parseFloat(parentEle.offsetHeight) - nowTransform <=
            parseFloat(targetList.offsetHeight) - parseFloat(that.bottomPromptElement.offsetHeight)) {
            return;
        }
        else {
            targetList.style.transitionDuration = "300ms";
            //下拉
            if (nowTransform >= 0) {
                nowTransform = 0;
                targetList.style.webkitTransform = "initial";
            }
            //上拉
            else {
                nowTransform = parseFloat(that.bottomPromptElement.offsetHeight)
                    + parseFloat(parentEle.offsetHeight)- parseFloat(targetList.offsetHeight);
                targetList.style.webkitTransform = "translate(0," + nowTransform + "px)";
            }
        }
        that.topPromptElement.innerHTML = "下拉刷新";
        that.bottomPromptElement.innerHTML = that.hasMoreRecord == true ? "上拉加载" : "没有更多记录";
    };
    that.hasMoreRecord = true;
    //设定一个布尔值，表示是否有更多记录可供加载
    that.setMoreRecord = function (flag) {
        that.hasMoreRecord = flag;
    };
}