﻿var Util = (function () {
    var that;
    var obj = function () {
        that = this;

        this.ajaxCount = 0;
        this.popId = [];
        this.urlParam = {
            projectId: this.getQueryString("projectId"),
            cityId: this.getQueryString("cityId"),
            openId: this.getQueryString("openId")
        };
    };

    obj.prototype = {
        getQueryString: function (name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
            var r = window.location.search.substr(1).match(reg);
            if (r != null) return unescape(r[2]);
            return "";
        },

        getApiUrl: function (method, param) {
            var url = "";
            ////FixedStart liyl 2016/12/27  https的判断
            //var ishttps = 'https:' == document.location.protocol ? true : false;
            //if (ishttps) {
            //    url = Config.HttpsApi.replace("{method}", method);
            //} else {
            //    url = Config.Api.replace("{method}", method);
            //}
            ////FixedEnd  
            //FixedStart liyl 2016/12/28  https的判断
            if (this.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                url = Config.HttpsApi.replace("{method}", method);
            } else {
                url = Config.Api.replace("{method}", method);
            }
            //FixedEnd
            if (param) {
                if (url.indexOf("?") < 0) url += "?";
                for (var key in param) {
                    url += key + "=" + param[key] + "&";
                }
                url = url.substring(0, url.length - 1);
            }
            console.log(url);
            return url;
        },

        showChildPage: function ($timeout, closeFn) {
            $(".nav").hide();
            var btnColse = document.createElement("div");
            btnColse.className = "btn_close";
            btnColse.addEventListener("click", function () {
                if (closeFn) {
                    if ($timeout) {
                        $timeout(closeFn)
                    } else {
                        closeFn();
                    }
                }
                $(".nav").show();
                $(this).remove();
            }, false);
            document.body.appendChild(btnColse);
        },

        info: function (msg, state) {
            if (top != window) {
                top.Util.info(msg);
                return;
            }

            $(".pop_info").remove();

            var div = document.createElement("div");
            div.className = "pop_info";
            div.style.cssText = "position:fixed;bottom: top;left:0;width:100%;text-align:center;z-index:10000;top: 0;";

            var innerDiv = document.createElement("div");
            innerDiv.className = "common_info_box_div";

            var html = '';
            if (state) {
                html += '<img class="common_info_state_img " src="images/success.png"/>';
            } else {
                html += '<img class="common_info_state_img " src="images/prompt.png"/>';
            }
            html += '<div >' + msg + '</div>'
            innerDiv.innerHTML = html;
            div.appendChild(innerDiv);

            top.document.body.appendChild(div);
            setTimeout(function () {
                $(div).remove();
            }, 1500);
        },

        redirect: function (url, param, isNewWindow) {
            url = this.getRedirectPath(url, param);

            if (!isNewWindow) {
                location.href = url;
            }
            else {
                window.open(url, "newwindow", "fullscreen=yes");
            }
        },

        getRedirectPath: function (url, param) {
            ////FixedStart lijq 2016/12/27  https的判断
            //var ishttps = 'https:' == document.location.protocol ? true: false;
            //if(ishttps){
            //    url = Config.HttpsRootPath + url;
            //}else{
            //    url = Config.RootPath + url;
            //}
            ////FixedEnd
            //FixedStart liyl 2016/12/28  https的判断
            if (this.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                url = Config.HttpsRootPath + url;
            } else {
                url = Config.RootPath + url;
            }
            //FixedEnd
            while (url.lastIndexOf("?") == url.length - 1
                || url.lastIndexOf("&") == url.length - 1) {
                url = url.substring(0, url.length - 1);
            }

            if (url.indexOf("?") < 0) {
                url += "?";
            } else {
                url += "&";
            }

            if (param) {
                for (var key in param) {
                    url += key + "=" + param[key] + "&";
                }
            }
            url += "_rtype=1#mp.weixin.qq.com";

            return url;
        },

        ajax: function (option, callback, errCallback, timeout) {
            //var loginInfo = Cache.getCache("DriverLoginInfo");
            //if (loginInfo && loginInfo.UserId && loginInfo.Timestump && loginInfo.LoginInfoSign) {
            //    if (option.data) {
            //        option.data.USER_ID = loginInfo.UserId;
            //        option.data.TIMEFLAG = loginInfo.Timestump;
            //        option.data.SIGN_STR = loginInfo.LoginInfoSign;
            //    }
            //    else {
            //        option.data = {
            //            USER_ID: loginInfo.UserId,
            //            TIMEFLAG: loginInfo.Timestump,
            //            SIGN_STR : loginInfo.LoginInfoSign
            //        };
            //    }
            //}
            $.ajax({
                type: 'POST',
                url: option.url,
                data: option.data,
                dataType: "text",
                timeout: timeout ? timeout : 10000,
                success: function (data) {
                    //console.log(data);
                    if (data) {
                        data = JSON.parse(data);
                    }
                    if (data.RespCode == -1000) {
                        //身份鉴权失败
                        Util.info(data.RespDesc);
                        toPage("pnl_login");
                        return;
                    }
                    if (callback) {
                        callback(data);
                    }
                },
                error: function (e, msg) {
                    console.log(msg);
                    if (msg == "timeout") {
                        //that.info("您的网络有问题哦~");
                    }
                    else {  
                        that.info("您的网络有问题哦~");
                    }
                    if (errCallback) {
                        errCallback(msg);
                    }
                }
            });
        },

        ajaxL: function (option, callback, errCallback, timeout) {
            Util.showAppLoading();
            $.ajax({
                type: 'POST',
                url: option.url,
                data: option.data,
                dataType: "text",
                timeout: timeout ? timeout : 10000,
                success: function (data) {
                    Util.hideAppLoading();
                    //console.log(data);
                    if (data) {
                        data = JSON.parse(data);
                    }
                    if (data.RespCode == -1000) {
                        //身份鉴权失败
                        Util.info(data.RespDesc);
                        toPage("pnl_login");
                        return;
                    }
                    if (callback) {
                        callback(data);
                    }
                },
                error: function (e, msg) {
                    Util.hideAppLoading();
                    console.log(msg);
                    if (msg == "timeout") {
                        //that.info("您的网络有问题哦~");
                    }
                    else {
                        that.info("您的网络有问题哦~");
                    }
                    if (errCallback) {
                        errCallback(msg);
                    }
                }
            });
        },

        showLoading: function (beforePage) {
            this.ajaxCount++;

            var loading = top.document.getElementById("loading");
            if (!loading) {
                loading = document.createElement("div");
                loading.id = "loading";
                loading.style.zIndex = 1000;
                loading.style.width = "100%";
                loading.style.height = $("#afui").css("height");
                loading.style.top = "0";
                loading.style.left = "0";
                loading.style.textAlign = "center";
                loading.style.position = "absolute";
                loading.style.backgroundColor = "white";
                loading.style.opacity = "1";
                var loadingGif = new Image();
                loadingGif.src = "images/loading.gif";
                loadingGif.style.width = "20%";
                loadingGif.style.marginTop = "30%";
                var text = document.createElement("div");
                text.innerHTML = "数据加载中";
                text.style.marginTop = "20px";
                text.style.fontSize = "16pt";
                text.style.color = "#10B060";
                loading.appendChild(loadingGif);
                loading.appendChild(text);
                document.getElementById("content").appendChild(loading);
            }
        },

        showAppLoading:function(){
            var loading = top.document.getElementById("apploading");
            if (!loading) {
                loading = document.createElement("div");
                loading.id = "apploading";
                loading.style.zIndex = 1001;
                loading.style.width = "100%";
                loading.style.height = "100%";
                loading.style.top = "0";
                loading.style.left = "0";
                loading.style.textAlign = "center";
                loading.style.position = "absolute";
                loading.style.opacity = "1";
                loading.innerHTML = '<div style="width: 30%;margin-top:70%;margin-left: 35%;opacity: 0.6;background-color: #000000;border-radius: 8%;padding: 10px;"><img src="images/app_loading.gif" style="width: 70%;border-radius: 8%;"></div>';

                top.document.body.appendChild(loading);
            }
        },

        hideAppLoading: function () {
            var loading = top.document.getElementById("apploading");
            if (loading) {
                top.document.body.removeChild(loading);
            }
        },

        hideLoading: function () {
            this.ajaxCount--;
            if (this.ajaxCount <= 0) {
                var loading = top.document.getElementById("loading");
                if (loading) {
                    top.document.body.removeChild(loading);
                }
                this.ajaxCount = 0;
            }
        },

        backLoading: function (beforePage) {
            this.ajaxCount--;

            if (this.ajaxCount <= 0) {
                var loading = top.document.getElementById("loading");
                if (loading) {
                    top.document.body.removeChild(loading);

                    $.ui.loadContent(beforePage, true, true, "slide");

                }
                this.ajaxCount = 0;
            }
        },

        //过场动画
        showTransLoading: function () {
            var loading = top.document.getElementById("transloading");
            if (!loading) {
                loading = document.createElement("div");
                loading.id = "loading";
                loading.style.zIndex = 1001;
                loading.style.width = "100%";
                loading.style.height = "100%";
                loading.style.top = "0";
                loading.style.textAlign = "center";
                loading.style.lineHeight = "300px";
                loading.style.position = "fixed";
                loading.style.opacity = "1";
                loading.innerHTML = '<img src="images/transit.gif" style="width:100%;height:100%;" />';
                top.document.body.appendChild(loading);
                $(loading).css("-webkit-transition-duration", "1400ms");

                setTimeout(function () {
                    $(loading).css("opacity", "0");
                }, 100);
                setTimeout(function () {
                    $(loading).remove();
                }, 1500);
            }
        },

        getTime: function (str) {
            return parseFloat(/(\d+)/.exec(str)[1]);
        },

        alert: function (msg) {
            alert(msg);
        },

        isMobile: function (v) {
            var reg = /^(1\d{10})$/;
            return reg.test(v);
        },

        isPassword:function(v){
            var reg=/^[a-zA-Z0-9]{6,16}$/;
            return reg.test(v);
        },

        isInteger: function (v) {
            var reg = /^(\-?\d+)$/;
            return reg.test(v);
        },

        isZipCode: function (v) {
            var reg = /^[1-9]\d{5}(?!\d)$/;
            return reg.test(v);
        },

        isEmpty: function (v) {
            return !v || /^\s*$/.test(v);
        },

        getDateStr: function (strDate) {
            var r = /(\d+)/.exec(strDate);
            if (r) {
                var date = new Date(parseFloat(r[1]));
                return that.getDateString(date);
            }

            return "";
        },

        getDateString: function (dt) {
            return dt.getFullYear() + "-" + (dt.getMonth() + 1) + "-" + dt.getDate();
        },

        formatDateStr:function(date){
            var dateStr = date.getFullYear() + "-";
            if ((date.getMonth() + 1).toString().length < 2) {
                dateStr += "0" + (date.getMonth() + 1) + "-";
            }
            else {
                dateStr += (date.getMonth() + 1) + "-";
            }
            if (date.getDate().toString().length < 2) {
                dateStr += "0" + date.getDate();
            }
            else {
                dateStr += date.getDate();
            }
            return dateStr;
        },

        //将字符串转换为日期
        // 字符串类型：yyyy-MM-dd
        stringToDate:function(str){
            var item = str.split('-');
            return new Date(item[0], item[1], item[3]);
        },

        callPhone: function (tel) {
            location.href = "tel:" + tel;
        },

        getQueryString: function (name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
            var r = window.location.search.substr(1).match(reg);
            if (r != null)
                return unescape(r[2]);
            return null;
        },

        // 弹出确认框 noCancel为true时，不显示取消按钮，否则显示取消按钮
        popConfirm: function (title, content, callback, noCancel) {
            var dialog_shadow = document.createElement("div");
            var popId = that._getRandomId();
            top.Util.popId.push(popId);
            dialog_shadow.id = popId;
            dialog_shadow.className = "index_bg";

            var dialog = document.createElement("div");
            var dialogId = that._getRandomId();
            top.Util.popId.push(dialogId);
            dialog.id = dialogId;
            dialog.className = "pop_dialog";

            var pageStyle = "max-height:" + (top.document.documentElement.clientHeight - 249) + "px;";
            var html = '<div class="pop_dialog_title">' + title + '</div>'
				+ '<div class="pop_dialog_content" style="' + pageStyle + '">' + content + '</div>'
				+ '<div class="pop_dialog_ft">';
            if (!noCancel) {
                html += '<input type="button" class="pop_two_btn"  value="取消" id="dialog_cancel" />';
                html += '<input type="button" class="pop_two_btn"  value="确定" id="dialog_confirm" />';
            }else{
                html += '<input type="button" class="pop_only_btn" value="确定" id="dialog_confirm"/>';
            }
            html += '</div>';
            dialog.innerHTML = html;
            top.document.body.appendChild(dialog_shadow);
            top.document.body.appendChild(dialog);
            if (!noCancel) {
                dialog.querySelector("#dialog_cancel").addEventListener("touchend", function () {
                    setTimeout(function () {
                        dialog_shadow.remove();
                        dialog.remove();
                        callback(false);
                    }, 400);
                    
                }, false);
            }
            dialog.querySelector("#dialog_confirm").addEventListener("touchend", function () {
                setTimeout(function () {
                    dialog_shadow.remove();
                    dialog.remove();
                    callback(true);
                }, 400);
                
            }, false);

            dialog_shadow.style.display = "block";
            dialog.style.display = "block";
        },

        // 弹出购买鲜花
        popBuyFlower: function (callback) {
            var dialog_shadow = document.createElement("div");
            var popId = that._getRandomId();
            top.Util.popId.push(popId);
            dialog_shadow.id = popId;
            dialog_shadow.className = "index_bg";

            var dialog = document.createElement("div");
            var dialogId = that._getRandomId();
            top.Util.popId.push(dialogId);
            dialog.id = dialogId;
            dialog.className = "pop_dialog";

            var html = '<div class="pop_dialog_title">购买鲜花</div>'
				+ '<div class="pop_dialog_content_flower">'
                + '<span>1鲜花=10积分</span>'
                + '<div id="dialog_decrease" > <img  src="images/recharge/jian.png"/></div>'
                + '<input id="dialog_flower_number" type="number" readonly="readonly"  value="1"/>'
                + '<div id="dialog_add"><img id="dialog_add" src="images/recharge/add.png"/> </div>'
                + '</div>'
				+ '<div class="pop_dialog_ft">';
                html += '<input type="button" class="pop_two_btn"  value="取消" id="dialog_cancel" />';
                html += '<input type="button" class="pop_two_btn"  value="确定" id="dialog_confirm" />';
                html += '</div>';
            dialog.innerHTML = html;
            top.document.body.appendChild(dialog_shadow);
            top.document.body.appendChild(dialog);
            // 减少
            dialog.querySelector("#dialog_decrease").addEventListener("touchstart", function () {
                var number = dialog.querySelector("#dialog_flower_number").value;
                if (number < 2) {
                    return;
                } else {
                    dialog.querySelector("#dialog_flower_number").value = --number;
                }
            }, false);
            // 增加
            dialog.querySelector("#dialog_add").addEventListener("touchstart", function () {
                var number = dialog.querySelector("#dialog_flower_number").value;
                dialog.querySelector("#dialog_flower_number").value = ++number;
            }, false);
            // 取消
            dialog.querySelector("#dialog_cancel").addEventListener("touchend", function () {
                setTimeout(function(){
                    dialog_shadow.remove();
                    dialog.remove();
                    callback(false, 0);
                },400)
            }, false);
            // 确定
            dialog.querySelector("#dialog_confirm").addEventListener("touchend", function () {
                setTimeout(function () {
                    dialog_shadow.remove();
                    dialog.remove();
                    callback(true, dialog.querySelector("#dialog_flower_number").value);
                }, 400);
            }, false);

            dialog_shadow.style.display = "block";
            dialog.style.display = "block";
        },

        _bindDialogEvent: function (selector, result, callback) {
            var dialog_shadow = top.document.getElementById(top.Util.popId[top.Util.popId.length - 1]);
            dialog_shadow.querySelector(selector).addEventListener("click", function () {
                var value = (typeof result) == "function" ? result(top.document.getElementById(top.Util.popId[top.Util.popId.length - 1])) : result;
                if (value == undefined) {
                    return;
                }

                top.document.body.removeChild(top.document.getElementById(top.Util.popId[top.Util.popId.length - 1]));
                top.Util.popId.pop();
                Util._callback(callback, value);
            }, false);
        },

        _callback: function (callback, result) {
            if (!callback) return;

            callback(result);
        },

        _getRandomId: function () {
            return "ID" + Math.random().toString().substring(2);
        },
		IsDate : function(op, formatString){
			formatString = formatString || "ymd";
			var m, year, month, day;
			switch(formatString){
				case "ymd" :
					m = op.match(new RegExp("^((\\d{4})|(\\d{2}))([-./])(\\d{1,2})\\4(\\d{1,2})$"));
					if(m == null ) return false;
					day = m[6];
					month = m[5]*1;
					year =  (m[2].length == 4) ? m[2] : GetFullYear(parseInt(m[3], 10));
					break;
				case "dmy" :
					m = op.match(new RegExp("^(\\d{1,2})([-./])(\\d{1,2})\\2((\\d{4})|(\\d{2}))$"));
					if(m == null ) return false;
					day = m[1];
					month = m[3]*1;
					year = (m[5].length == 4) ? m[5] : GetFullYear(parseInt(m[6], 10));
					break;
				default :
					break;
			}
			if(!parseInt(month)) return false;
			month = month==0 ?12:month;
			var date = new Date(year, month-1, day);
			return (typeof(date) == "object" && year == date.getFullYear() && month == (date.getMonth()+1) && day == date.getDate());
			function GetFullYear(y){return ((y<30 ? "20" : "19") + y)|0;}
		},

		
		IsIdCard : function(number){
			var date, Ai;
			var verify = "10x98765432";
			var Wi = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
			var area = ['','','','','','','','','','','','北京','天津','河北','山西','内蒙古','','','','','','辽宁','吉林','黑龙江','','','','','','','','上海','江苏','浙江','安微','福建','江西','山东','','','','河南','湖北','湖南','广东','广西','海南','','','','重庆','四川','贵州','云南','西藏','','','','','','','陕西','甘肃','青海','宁夏','新疆','','','','','','台湾','','','','','','','','','','香港','澳门','','','','','','','','','国外'];
			var re = number.match(/^(\d{2})\d{4}(((\d{2})(\d{2})(\d{2})(\d{3}))|((\d{4})(\d{2})(\d{2})(\d{3}[x\d])))$/i);
			if(re == null) return false;
			if(re[1] >= area.length || area[re[1]] == "") return false;
			if(re[2].length == 12){
				Ai = number.substr(0, 17);
				date = [re[9], re[10], re[11]].join("-");
			}
			else{
				Ai = number.substr(0, 6) + "19" + number.substr(6);
				date = ["19" + re[4], re[5], re[6]].join("-");
			}
			if(!this.IsDate(date, "ymd")) return false;
			var sum = 0;
			for(var i = 0;i<=16;i++){
				sum += Ai.charAt(i) * Wi[i];
			}
			Ai +=  verify.charAt(sum%11);
			return (number.length ==15 || number.length == 18 && number == Ai);
		},
        
        //本地存储
		saveOnLocal: function (key, data) {
		    if (window.localStorage) {
		        localStorage[key] = JSON.stringify(data);
		    }
		    else {
		        console.log("webkit不支持本地存储");
		    }
		},

        //从本地存储获取
		getDataFromLocal: function (key) {
		    if (window.localStorage) {
		        var target = localStorage[key];
		        if (target) {
		            return JSON.parse(target);
		        }
		        else {
		            return null;
		        }
		    }
		    else {
		        console.log("webkit不支持本地存储");
		    }
		},

        //金额格式化
		parseMoney: function (s, n) {
		    n = n > 0 && n <= 20 ? n : 2;
		    s = parseFloat((s + "").replace(/[^\d\.-]/g, "")).toFixed(n) + "";
		    var l = s.split(".")[0].split("").reverse(),
            r = s.split(".")[1];
		    t = "";
		    for (i = 0; i < l.length; i++) {
		        t += l[i] + ((i + 1) % 3 == 0 && (i + 1) != l.length ? "," : "");
		    }
		    return t.split("").reverse().join("") + "." + r;
		},

        //Sql拼接字符串转义
		encodeSqlStr: function (str) {
		    return str.replace(new RegExp(/\\/g), "\\\\").replace(new RegExp(/"/g), '\\"').replace(new RegExp(/'/g), "\\'");
		},

		decodeSqlStr: function (str) {
		    return str.replace(new RegExp(/\\'/g), '\'').replace(new RegExp(/\\"/g), '"').replace(new RegExp(/\\\\/g), '\\');
		},

		stringToHex: function (str){
		    var val="";
		    for(var i = 0; i < str.length; i++){

		        if(val == "")
		            val = str.charCodeAt(i).toString(16);
		        else
		            val += "," + str.charCodeAt(i).toString(16);
		    }
		    return val;
		},

		hexToString:function (str){
		    var val="";
		    var arr = str.split(",");
		    for(var i = 0; i < arr.length; i++){
		        val += String.fromCharCode(parseInt(arr[i],16));
		    }
		    return val;
		},
        
        //异步加载JS
		loadJs: function (fileUrl, callback) {
		    //获取所有script标签
		    var scriptTags = document.getElementsByTagName('script');
		    //移除相同url的标签
		    for (var i = 0; i < scriptTags.length; i++) {
		        if (fileUrl == scriptTags[i].getAttribute("src")) {
		            $(scriptTags[i]).remove();
		        }
		    }
		    //引入新JS标签
		    var oHead = document.getElementsByTagName('HEAD').item(0);
		    var oScript = document.createElement("script");
		    oScript.type = "text/javascript";
		    oScript.src = fileUrl;
		    //设置回调
		    oScript.onload = callback;
		    oHead.appendChild(oScript);
		},

        //appframework专用，刷新panel
		refreshPanel: function (id, callback) {
		    var el = document.getElementById(id);
		    if (!el || !el.getAttribute("data-defer")) {
		        return;
		    }
		    $.ajax({
		        url: el.getAttribute("data-defer"),
		        success: function (data) {
		            $.ui.updatePanel("#" + id, data);
		            that.parseScriptTags($.query("#" + id).get(0));
		            if (callback) {
		                callback();
		            }
		        },
		        error: function (msg) {
		            console.log(msg);
		        }
		    });
		},

		parseScriptTags: function (div) {
		    if (!div) return;
		    $.parseJS(div);
		},

        //操作系统判断
		getSystemType: function () {
		    var u = navigator.userAgent;
		    if (u.indexOf('Android') > -1 || u.indexOf('Linux') > -1) {
		        return "Android";
		    }
		    else if (u.indexOf('iPhone') > -1 || u.indexOf('iPad') > -1) {
		        return "IOS";
		    }
		    else {
		        return "Default";
		    }
		},
        
        //字符串左补齐
		padLeft: function (baseStr, length, char) {
		    while (baseStr.length < length) {
		        baseStr = char + baseStr;
		    }
		    return baseStr;
		},

        //字符串右补齐
		padRight: function (baseStr, length, char) {
		    while (baseStr.length < length) {
		        baseStr += char;
		    }
		    return baseStr;
		},
        
        //从数组中随机获取randomCount条记录，并以一个新的数组返回
		randomArray: function (arrayList, randomCount) {
		    if (arrayList.length <= randomCount) {
		        return arrayList;
		    }
		    var sortArr = [];
            //生成排序随机种子
		    for (var i = 0; i < arrayList.length; i++) {
		        sortArr.push({ index: i, sortKey: Math.random() });
		    }
		    sortArr.sort(function (a, b) {
		        return a.sortKey - b.sortKey;
		    });
		    var res = [];
		    for (var i = 0; i < randomCount; i++) {
		        res.push(arrayList[sortArr[i].index]);
		    }
		    sortArr = null;
		    return res;
		},

        // 自定义弹框弹出确认框 noCancel为true时，不显示取消按钮，否则显示取消按钮
		customConfirm: function (content, callback, noCancel) {
		    var dialog_shadow = document.createElement("div");
		    var popId = that._getRandomId();
		    top.Util.popId.push(popId);
		    dialog_shadow.id = popId;
		    dialog_shadow.className = "index_bg";

		    var dialog = document.createElement("div");
		    var dialogId = that._getRandomId();
		    top.Util.popId.push(dialogId);
		    dialog.id = dialogId;
		    dialog.className = "pop_dialog";

		    var pageStyle = "max-height:" + (top.document.documentElement.clientHeight - 249) + "px;";
		    var html = '<div class="custom_dialog_content" style="' + pageStyle + '">' + content + '</div>'
				+ '<div class="pop_dialog_ft">';
		    if (!noCancel) {
		        html += '<input type="button" class="pop_two_btn"  value="取消" id="dialog_cancel" />';
		        html += '<input type="button" class="pop_two_btn"  value="确定" id="dialog_confirm" />';
		    } else {
		        html += '<input type="button" class="pop_only_btn" value="确定" id="dialog_confirm"/>';
		    }
		    html += '</div>';
		    dialog.innerHTML = html;
		    top.document.body.appendChild(dialog_shadow);
		    top.document.body.appendChild(dialog);
		    if (!noCancel) {
		        dialog.querySelector("#dialog_cancel").addEventListener("click", function () {
		            dialog_shadow.remove();
		            dialog.remove();
		            callback(false);
		        }, false);
		    }
		    dialog.querySelector("#dialog_confirm").addEventListener("click", function () {
		        dialog_shadow.remove();
		        dialog.remove();
		        callback(true);
		    }, false);

		    dialog_shadow.style.display = "block";
		    dialog.style.display = "block";
		},

        
        //过滤表情 byzhusj 2016/12/15
		isValidChar: function (keyNum) {
		    if (keyNum > 65535) {
		        return false;
		    }
		    return true;
        },

        // 格式化时间间隔
		formatTimeSpan: function (seconds) {
		    var m = Math.floor(seconds/60)<10 ? "0"+Math.floor(seconds/60) : Math.floor(seconds/60);
		    var s = Math.floor(seconds-(m*60))<10 ? "0"+Math.floor(seconds-(m*60)) : Math.floor(seconds-(m*60));
		    return m+":"+s;
		},

		isEmojiCharacter: function(substring) {
            for ( var i = 0; i < substring.length; i++) {  
                var hs = substring.charCodeAt(i);  
                if (0xd800 <= hs && hs <= 0xdbff) {  
                    if (substring.length > 1) {  
                        var ls = substring.charCodeAt(i + 1);  
                        var uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;  
                        if (0x1d000 <= uc && uc <= 0x1f77f) {  
                            return true;  
                        }  
                    }  
                } else if (substring.length > 1) {  
                    var ls = substring.charCodeAt(i + 1);  
                    if (ls == 0x20e3) {  
                        return true;  
                    }  
                } else {  
                    if (0x2100 <= hs && hs <= 0x27ff) {  
                        return true;  
                    } else if (0x2B05 <= hs && hs <= 0x2b07) {  
                        return true;  
                    } else if (0x2934 <= hs && hs <= 0x2935) {  
                        return true;  
                    } else if (0x3297 <= hs && hs <= 0x3299) {  
                        return true;  
                    } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030  
                            || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b  
                            || hs == 0x2b50) {  
                        return true;  
                    }  
                }  
            }  
        }  ,

    };

    return new obj();
})();