﻿//命名空间定义
var ZebDev = zebra.namespace("ZebDevdexterity");
var mainZebDevPanel, zebDevNotiHandler;
ZebDev("happymusic").homework = zebra.Class([
    function (readonly, notiHandler) {
        var that = this;
        if (typeof notiHandler == 'function') {
            zebDevNotiHandler = notiHandler;
        }
        else {
            zebDevNotiHandler = function (msg) { alert(msg); };
        }
        //是否只读
        that.readonly = readonly;
        //画布创建
        var w = window.screen.width;
        var h = window.screen.height * 0.75;
        that.canvas = new zebra.ui.zCanvas(w, h);
        that.canvas.setStyles({ bottom: 0, position: 'absolute' });
        var root = that.canvas.root;
        //创建主panel
        mainZebDevPanel = new zebra.ui.Panel();
        mainZebDevPanel.setBounds(0, 0, w, h);
        //mainZebDevPanel.setBackground("#E8E8EC");
        mainZebDevPanel.mouseDragStarted = function (e) {
            if (that.readonly == true) {
                return;
            }
            if (that.paintingCircle
                && (that.zebraCompList.length > 0 ? that.zebraCompList[that.zebraCompList.length - 1].instance : {}) != that.paintingCircle) {
                that.paintingCircle.removeMe();
                that.txtBtn.removeMe();
                that.recordBtn.removeMe();
                that.goodBtn.removeMe();
            }
            //记录起点坐标
            that.dragStartPt = {
                x: e.absX,
                y: that.dragCount == 0 ? e.absY - window.screen.height*0.25 : e.absY
            };
            that.dragCount++;
            that.paintingCircle = (new ZebDev.shape.circle(that.dragStartPt.x, that.dragStartPt.y, 1, 1)).toZebraComp();
            mainZebDevPanel.add(that.paintingCircle);
        };
        mainZebDevPanel.mouseDragEnded = function (e) {
            if (that.readonly == true) {
                return;
            }
            that.paintingCircle.setSize(that.circleParam.xAxis, that.circleParam.yAxis);
            that.paintingCircle.setLocation(that.circleParam.x, that.circleParam.y);
            //生成操作按钮
            //中间按钮坐标，直径
            var diameter = w * 0.1;
            var midBtnX = that.circleParam.x + that.circleParam.xAxis / 2 - diameter / 2;
            var midBtnY = that.circleParam.y - diameter - 10;
            //左右越界调整
            if (midBtnX - diameter - 5 < 0) {
                midBtnX = diameter + 5;
            }
            if (midBtnX + diameter * 2 + 5 > w) {
                midBtnX = w - diameter * 2 - 5;
            }
            //上越界调整
            if (midBtnY + diameter <= 0) {
                midBtnY = 0 - diameter + 1;
            }

            //文本输入
            that.txtBtn = new ZebDev.shape.button(midBtnX - diameter - 5, midBtnY, diameter, '#007ACC', '文本',
                function (e) {
                    var pop = new ZebDev.shape.popup(ZebDev.shape.popupType.text, function (inputText) {
                        //移除按钮
                        that.txtBtn.removeMe();
                        that.recordBtn.removeMe();
                        that.goodBtn.removeMe();

                        var tagConfig = {
                            left: midBtnX,
                            top: midBtnY + 10*2/3,
                            diameter: diameter * 2 / 3,
                            content: inputText,
                            contentType: ZebDev.shape.popupType.text
                        }
                        var tag = new ZebDev.shape.tag(tagConfig.left, tagConfig.top, tagConfig.diameter, tagConfig.content, tagConfig.contentType).toZebraComp();
                        mainZebDevPanel.add(tag);

                        //将内容插入到组件列表
                        that.zebraCompList.push({
                            instance: that.paintingCircle,
                            type: ZebDev.shape.compType.circle,
                            config: that.circleParam,
                            content: inputText,
                            tag: {
                                instance: tag,
                                config: tagConfig
                            }
                        });
                    });
                    pop.pop();
                }).toZebraComp();
            //语音输入
            that.recordBtn = new ZebDev.shape.button(midBtnX, midBtnY, diameter, 'green', '语音',
                function () {

                    //移除按钮
                    that.txtBtn.removeMe();
                    that.recordBtn.removeMe();
                    that.goodBtn.removeMe();
                }).toZebraComp();
            //表扬
            that.goodBtn = new ZebDev.shape.button(midBtnX + diameter + 5, midBtnY, diameter, 'red', '赞',
                function () {
                    //移除按钮
                    that.txtBtn.removeMe();
                    that.recordBtn.removeMe();
                    that.goodBtn.removeMe();

                    var zanText = "这里很不错！";

                    var tagConfig = {
                        left: midBtnX,
                        top: midBtnY + 10 * 2 / 3,
                        diameter: diameter * 2 / 3,
                        content: zanText,
                        contentType: ZebDev.shape.popupType.zan
                    }
                    var tag = new ZebDev.shape.tag(tagConfig.left, tagConfig.top, tagConfig.diameter, tagConfig.content, tagConfig.contentType).toZebraComp();
                    mainZebDevPanel.add(tag);

                    //将内容插入到组件列表
                    that.zebraCompList.push({
                        instance: that.paintingCircle,
                        type: ZebDev.shape.compType.circle,
                        config: that.circleParam,
                        content: zanText,
                        tag: {
                            instance: tag,
                            config: tagConfig
                        }
                    });
                }).toZebraComp();
            mainZebDevPanel.add(that.txtBtn);
            mainZebDevPanel.add(that.recordBtn);
            mainZebDevPanel.add(that.goodBtn);

            that.dragStartPt = null;
            that.curPt = null;
        };
        mainZebDevPanel.mouseDragged = function (e) {
            if (that.readonly == true) {
                return;
            }
            //当前坐标点
            that.curPt = { x: e.absX, y: e.absY };
            that.circleParam = { };
            //x坐标比较
            if (that.curPt.x > that.dragStartPt.x) {
                that.circleParam.xAxis = that.curPt.x - that.dragStartPt.x;
                that.circleParam.x = that.dragStartPt.x;
            }
            else if (that.curPt.x < that.dragStartPt.x) {
                that.circleParam.xAxis = that.dragStartPt.x - that.curPt.x;
                that.circleParam.x = that.curPt.x;
            }
            else {
                that.circleParam.xAxis = 1;
                that.circleParam.x = that.curPt.x;
            }
            //y坐标比较
            if (that.curPt.y > that.dragStartPt.y) {
                that.circleParam.yAxis = that.curPt.y - that.dragStartPt.y;
                that.circleParam.y = that.dragStartPt.y;
            }
            else if (that.curPt.y < that.dragStartPt.y) {
                that.circleParam.yAxis = that.dragStartPt.y - that.curPt.y;
                that.circleParam.y = that.curPt.y;
            }
            else {
                that.circleParam.yAxis = 1;
                that.circleParam.y = that.curPt.y;
            }
            that.paintingCircle.setSize(that.circleParam.xAxis, that.circleParam.yAxis);
            that.paintingCircle.setLocation(that.circleParam.x, that.circleParam.y);
        };
        mainZebDevPanel.mouseClicked = function (e) {
            if (that.paintingCircle
                && (that.zebraCompList.length > 0 ? that.zebraCompList[that.zebraCompList.length - 1].instance : {}) != that.paintingCircle) {
                that.paintingCircle.removeMe();
                that.txtBtn.removeMe();
                that.recordBtn.removeMe();
                that.goodBtn.removeMe();
            }
        };
        root.add(mainZebDevPanel);
        //zebra组件组
        that.zebraCompList = [];
        //drag次数，应对框架bug：第一次获取坐标不准
        that.dragCount = 0;
    },

    //获取已添加的zebra组件列表
    function getZebraCompList() {
        //移除实例的组件一览
        var resultList = [];
        if (this.zebraCompList) {
            for (var i = 0; i < this.zebraCompList.length; i++) {
                resultList.push({
                    type: this.zebraCompList[i].type,
                    config: this.zebraCompList[i].config,
                    content: this.zebraCompList[i].content,
                    tag: {
                        config: this.zebraCompList[i].tag.config
                    }
                })
            }
        }
        return resultList;
    },

    //通过组件列表在画布上还原zebra组件
    function reducteCompList(zebraCompList) {
        var curComp;
        this.zebraCompList = [];
        for (var i = 0; i < zebraCompList.length; i++) {
            curComp = zebraCompList[i];
            switch (curComp.type) {
                //圆
                case ZebDev.shape.compType.circle:
                    var circle, tag;
                    if (curComp.instance) {
                        circle = curComp.instance;
                    }
                    else {
                        circle = (new ZebDev.shape.circle(curComp.config.x, curComp.config.y, curComp.config.xAxis, curComp.config.yAxis)).toZebraComp();
                    }
                    if (curComp.tag && curComp.tag.instance) {
                        tag = curComp.tag.instance;
                    }
                    else {
                        tag = new ZebDev.shape.tag(curComp.tag.config.left, curComp.tag.config.top,
                            curComp.tag.config.diameter, curComp.tag.config.content, curComp.tag.config.contentType).toZebraComp();
                    }
                    mainZebDevPanel.add(circle);
                    mainZebDevPanel.add(tag);
                    //还原组件一览（带上实例）
                    this.zebraCompList.push({
                        instance: circle,
                        type: ZebDev.shape.compType.circle,
                        config: curComp.config,
                        content: curComp.content,
                        tag: {
                            instance: tag,
                            config: curComp.tag.config
                        }
                    });
                    break;
            }
        }
    },

    //清空画布
    function clearCanvas() {
        this.zebraCompList = [];
        mainZebDevPanel.removeAll();
    },

    //设置一个值，表示当前画布是否只读
    function setReadOnly(isReadOnly) {
        if (isReadOnly == true) {
            this.readonly = true;
        }
        else if (isReadOnly == false) {
            this.readonly = false;
        }
    }
]);

//图形-圆圈
ZebDev("shape").circle = zebra.Class([
    //左距，上距，x半轴长，y半轴长
    function (left, top, xAxis, yAxis) {
        this.left = left;
        this.top = top;
        this.xAxis = xAxis;
        this.yAxis = yAxis;
        this.color = 'red';
        this.borderWidth = '1px';
    },

    function toZebraComp() {
        var comp = new zebra.ui.HtmlElement('div');
        comp.setLocation(this.left, this.top);
        comp.setSize(this.xAxis, this.yAxis);
        comp.setStyles({
            border: this.color + ' ' + this.borderWidth + ' solid',
            borderRadius: '100%'
        });
        return comp;
    }
]);

//图形-操作按钮
ZebDev("shape").button = zebra.Class([
    //左距，上距，直径，背景色，文字内容，点击事件委托（可选）
    function (left, top, diameter, backgroundColor, txt, clickEvent) {
        this.left = left;
        this.top = top;
        this.diameter = diameter;
        this.backgroundColor = backgroundColor;
        this.color = '#fff';
        this.text = txt;

        if (typeof clickEvent == 'function') {
            this.clickEvent = clickEvent;
        }
    },

    function toZebraComp() {
        var comp = new zebra.ui.HtmlElement('div');
        comp.setColor(this.color);
        comp.setContent(this.text);
        comp.setStyles({
            borderRadius: '100%',
            fontSize: this.diameter / 3 + 'px',
            fontFamily:'微软雅黑',
            overflow: 'hidden',
            textAlign: 'center',
            lineHeight: this.diameter + 'px',
            backgroundColor: this.backgroundColor,
            opacity: 0.8
        });
        comp.setLocation(this.left, this.top);
        comp.setSize(this.diameter, this.diameter);
        if (this.clickEvent) {
            comp.element.addEventListener('click', this.clickEvent);
        }
        return comp;
    }
]);

//图形-标记
ZebDev("shape").tag = zebra.Class([
    //左距，上距，直径，内容，内容类型
    function (left, top, diameter, content, contentType) {
        this.left = left;
        this.top = top;
        this.diameter = diameter;
        this.content = content;
        this.contentType = contentType;
    },

    function toZebraComp() {
        var that = this;
        var comp = new zebra.ui.HtmlElement('div');
        that.comp = comp;
        comp.setStyles({
            borderRadius: '100%',
            fontSize: that.diameter / 3 + 'px',
            overflow: 'hidden',
            textAlign: 'center',
            opacity: 0.5,
            backgroundColor: "orange",
            webkitAnimation: this.contentType == ZebDev.shape.popupType.zan ? "zeb_dev_tag_ani_good 1.5s infinite linear" : "zeb_dev_tag_ani 3s infinite linear",
            lineHeight: that.diameter + 'px',
            color: '#DD00DB',
            fontSize: that.diameter * 2 / 3 + 'px',
            fontWeight: 'bolder'
        });
        comp.setLocation(that.left, that.top);
        comp.setSize(that.diameter, that.diameter);
        comp.element.addEventListener('click', function () { that.showContent(that); });

        var innerHtml = "";
        if (this.contentType == ZebDev.shape.popupType.text) {
            innerHtml = "<div class='Zeb_Dev_Tag_Center' style='width:" + that.diameter / 2 + "px;height:" + that.diameter / 2
                + "px;margin-left:" + that.diameter / 4 + "px;margin-top:" + that.diameter / 4 + "px;color:#fff;line-height:"
                + that.diameter / 2 + "px;text-align:center;font-weight:bolder;font-size:" + that.diameter * 2 / 3 + "px;'>!</div>";
        }
        else if (this.contentType == ZebDev.shape.popupType.zan) {
            innerHtml = "赞";
        }
        comp.setContent(innerHtml);
        return comp;
    },

    function showContent(entity) {
        var that = entity ? entity : this;
        if (that.contentType == ZebDev.shape.popupType.text
            || that.contentType == ZebDev.shape.popupType.zan) {
            that.tagText = (new ZebDev.shape.tagText(that.left, that.top, that.diameter, that.content,
                function () {
                    that.hideContent();
                })).toZebraComp();
            mainZebDevPanel.add(that.tagText);
            that.comp.removeMe();
        }
    },

    function hideContent() {
        mainZebDevPanel.add(this.comp);
        this.tagText.removeMe();
    }
]);

//图形-标记说明框
ZebDev("shape").tagText = zebra.Class([
    //左距，上距，直径，内容，点击事件委托（可选）
    function (left, top, diameter, txt, clickEvent) {
        this.left = left;
        this.top = top;
        this.diameter = diameter;
        this.txt = txt;
        this.color = "red";

        if (typeof clickEvent == 'function') {
            this.clickEvent = clickEvent;
        }
    },

    function toZebraComp() {
        var comp = new zebra.ui.HtmlElement('div');
        comp.setStyles({
            fontSize: this.diameter / 4 + 'px',
            textAlign: 'left',
            fontFamily: '微软雅黑'
        });
        comp.setColor(this.color);
        comp.setLocation(this.left, this.top);
        comp.setSize(this.diameter * 3, this.diameter);
        comp.setContent(this.txt);
        if (this.clickEvent) {
            comp.element.addEventListener('click', this.clickEvent);
        }
        return comp;
    }
]);

//图形-弹出框
ZebDev("shape").popup = zebra.Class([
    function (popupType, confirmCallback) {
        this.popupType = popupType;
        this.confirmCallback = confirmCallback;
    },

    function pop() {
        var w = window.screen.width;
        var h = window.screen.height;
        //阴影
        var shadow = document.getElementById("ZebDev_shape_popup_shadow");
        if (!shadow) {
            shadow = document.createElement("div");
            shadow.id = "ZebDev_shape_popup_shadow";
            shadow.style.zIndex = 1000;
            shadow.style.width = "100%";
            shadow.style.height = "100%";
            shadow.style.top = "0";
            shadow.style.left = "0";
            shadow.style.position = "fixed";
            shadow.style.opacity = "0.6";
            shadow.style.backgroundColor = "#000000";
            document.body.appendChild(shadow);
        }
        //窗体
        var popWin = document.getElementById("ZebDev_shape_popup_window");
        if (!popWin) {
            popWin = document.createElement("div");
            popWin.id = "ZebDev_shape_popup_window";
            popWin.style.zIndex = 1001;
            popWin.style.position = "absolute";
            popWin.style.backgroundColor = "#fff";
            popWin.style.fontFamily = "微软雅黑";
            popWin.style.width = (w * 0.6 < 200 ? 200 : w * 0.6) + 'px';
            popWin.style.height = 'auto';
            popWin.style.left = (w - parseInt(popWin.style.width)) / 2 + 'px';
            popWin.style.top = h * 0.2 + 'px';
            popWin.style.borderRadius = "10px";
            //文本输入
            if (this.popupType == ZebDev.shape.popupType.text) {
                var contentHtml = '<div style="text-align: center;padding-top: 8px;padding-bottom: 4px;">文本</div>';
                contentHtml += '<div style="text-align: center;padding-top: 4px;padding-bottom: 10px;"><textarea id="ZebDev_shape_popup_input" type="text" placeholder="最多30字..." style="width: 88%;height: 60px;border-radius: 4px;font-size: 16px;"></textarea></div>';
                contentHtml += '<div style="text-align: center;border-top: #E7E7E7 1px solid;">';
                contentHtml += '<div id="ZebDev_shape_popup_cancel" style="display: inline-block;width: ' + (parseInt(popWin.style.width) / 2 - 1) + 'px;border-right: #E7E7E7 1px solid;padding-top: 6px;padding-bottom: 6px;color: #6E7178;">取消</div>';
                contentHtml += '<div id="ZebDev_shape_popup_confirm" style="display: inline-block;width: 50%;padding-top: 6px;padding-bottom: 6px;color: #FD8345;">确定</div>';
                contentHtml += '</div>';
                popWin.innerHTML = contentHtml;
            }
            //语音输入
            else if (this.popupType == ZebDev.shape.popupType.record) {

            }
            document.body.appendChild(popWin);
            document.getElementById('ZebDev_shape_popup_cancel').addEventListener('click', this.close);
            var that = this;
            document.getElementById('ZebDev_shape_popup_confirm').addEventListener('click', function () {
                if (typeof that.confirmCallback == 'function') {
                    var inputText = document.getElementById('ZebDev_shape_popup_input').value.trim();
                    if (!inputText) {
                        zebDevNotiHandler('请输入内容');
                        return;
                    }
                    else if (inputText.length > 30) {
                        zebDevNotiHandler('内容不能超过30字');
                        return;
                    }
                    that.confirmCallback(inputText);
                }
                that.close();
            });
        }
    },

    function close() {
        var shadow = document.getElementById("ZebDev_shape_popup_shadow");
        var popWin = document.getElementById("ZebDev_shape_popup_window");
        if (popWin) {
            document.body.removeChild(popWin);
        }
        if (shadow) {
            document.body.removeChild(shadow);
        }
    }
]);

//图形类型
ZebDev("shape").compType = {
    circle: 1,
    button: 2,
    tag: 3
};

//弹框类型
ZebDev("shape").popupType = {
    text: 1,
    record: 2,
    zan: 3
};