var video = {
		    /*options={
		           videoObj,//video组件的dom
		           loadingobj,//loading的dom
		           current,//视频播放当前时间的dom
		           duration,//记录视频播放总时间的dom
		           timeBar,//播放时间条的dom
		           btnStop,//播放停止按钮dom
		           btnPlay,//播放按钮dom
		    }
		    */
			init : function(options) {
				self = this;
				self.options = options;
				self.videoObj = $(options.videoObj);
				self.videoObj[0].removeAttribute("controls");
				if(options.loadingobj && $(options.loadingobj).length>0){
					$(options.loadingobj).fadeIn(500);
					//todo lijq if(justep.Browser.isIOS){
						setTimeout(function(){
							$(options.loadingobj).fadeOut(500);
						},200);
					//}
				}
				//加载
				self.videoObj.on('loadedmetadata', function() {
					//set video properties
					$(self.options.current).text(self.timeFormat(0));
					$(self.options.duration).text(self.timeFormat(self.videoObj[0].duration));
					setTimeout(self.startBuffer, 150);
				});
				
				self.videoObj.on('timeupdate', function() {
					var currentPos = self.videoObj[0].currentTime;
					var maxduration = self.videoObj[0].duration;
					var perc = 100 * currentPos / maxduration;
					$(options.timeBar).css('width',perc+'%');	
					$(options.current).text(self.timeFormat(currentPos));	
				});
				
				//stop button clicked
				$(options.btnStop).on('touchstart', function() {
					$(options.btnPlay).removeClass('paused');
					self.updatebar($('.progress').offset().left);
					self.videoObj[0].pause();
				});
				$(self.options.playBtn).on('click', function() { self.playpause(true); } );
				self.videoObj.on('click', function() { 
					if(self.videoObj[0].paused)return;
					$(self.options.btnPlay).removeClass('paused');
					self.videoObj[0].pause();
					$(self.options.playBtn).show();
				} );
				//播放按钮
				$(options.btnPlay).on('touchstart', function() { self.playpause(); } );
				//video waiting for more data event
				self.videoObj.on('waiting', function() {
					$(options.loadingobj).fadeIn(200);
				});
				
				//VIDEO EVENTS
				//video canplay event
				self.videoObj.on('canplay', function() {
					$(options.loadingobj).fadeOut(100);
				});
				
				//video canplaythrough event
				//solve Chrome cache issue
				var completeloaded = false;
				self.videoObj.on('canplaythrough', function() {
					completeloaded = true;
				});
				
				//video ended event
				self.videoObj.on('ended', function() {
					$(options.btnPlay).removeClass('paused');
					self.videoObj[0].pause();
				});

				//video seeking event
				self.videoObj.on('seeking', function() {
					//if video fully loaded, ignore loading screen
					if(!completeloaded) { 
						$(options.loadingobj).fadeIn(200);
					}	
				});
				
				//video seeked event
				self.videoObj.on('seeked', function() { });
				
				//video waiting for more data event
				self.videoObj.on('waiting', function() {
					$(options.loadingobj).fadeIn(200);
				});
				
				var timeDrag = false;	/* check for drag event */
				$(options.progress).on('click', function(e) {
					timeDrag = true;
					self.updatebar(e.pageX);
				});
				
				self.videoload();
				//speed text clicked
				$(options.speedX1).on('touchstart', function() { self.fastfowrd(this, 1); });
				$(options.speedX3).on('touchstart', function() { self.fastfowrd(this, 3); });
				
			},//Time format converter - 00:00
			timeFormat:function(seconds){
				var m = Math.floor(seconds/60)<10 ? "0"+Math.floor(seconds/60) : Math.floor(seconds/60);
				var s = Math.floor(seconds-(m*60))<10 ? "0"+Math.floor(seconds-(m*60)) : Math.floor(seconds-(m*60));
				return m+":"+s;
			},startBuffer:function() {
				var currentBuffer = self.getEnd(self.videoObj[0]);
				var maxduration = self.videoObj[0].duration;
				var perc = 100 * currentBuffer / maxduration;
				$(self.options.bufferBar).css('width',perc+'%');
				if(currentBuffer < maxduration) {
					setTimeout(self.startBuffer, 250);
				}
			},fastfowrd : function(obj, spd) {//修改播放速度
				$('.text').removeClass('selected');
				$(obj).addClass('selected');
				self.videoObj[0].playbackRate = spd;
				self.videoObj[0].play();
				$(self.options.playBtn).hide();
			},updatebar:function(x) {//修改进度条
				var progress = $(self.options.progress);
				
				//calculate drag position
				//and update video currenttime
				//as well as progress bar
				var maxduration = self.videoObj[0].duration;
				var position = x - progress.offset().left;
				var percentage = 100 * position / progress.width();
				if(percentage > 100) {
					percentage = 100;
				}
				if(percentage < 0) {
					percentage = 0;
				}
				$(self.options.timeBar).css('width',percentage+'%');	
				self.videoObj[0].currentTime = maxduration * percentage / 100;
			},playpause:function() {
				if(self.videoObj[0].paused || self.videoObj[0].ended) {
					$(self.options.btnPlay).addClass('paused');
					self.videoObj[0].play();
					$(self.options.playBtn).hide();
				}
				else {
					$(self.options.btnPlay).removeClass('paused');
					self.videoObj[0].pause();
					$(self.options.playBtn).show();
				}
			},hideVideobar:function(){
				$(self.options.control).css("bottom","-60px");
				$(self.options.btnPlay).removeClass('paused');
				self.videoObj[0].pause();
				$(self.options.playBtn).hide();
			},showVideobar:function(){
				$(self.options.control).css("bottom","48px");
				$(self.options.playBtn).show();
			},getCurrentTime:function(){
				if(self.videoObj[0].currentTime<= (self.videoObj[0].duration-0.1)){
					return self.videoObj[0].currentTime;
				}else{
					return self.videoObj[0].duration-0.1;
				}
			},setCurrentTime:function(currentTime){
				self.videoObj[0].currentTime =currentTime;
			}, getEnd:function(video) {
				  var end = 0
				  try {
				    end = video.buffered.end(0) || 0
				    end = parseInt(end * 1000 + 1) / 1000
				  } catch(e) {
				  }
				  return end
				},//实现预加载-ios如未加载的话
			videoload: function () {
			     //if(justep.Browser.isIOS && self.videoObj[0].currentTime == 0){
  				 if(self.videoObj[0].currentTime == 0){
						//减小声音
						self.videoObj[0].volume = 0;
						$(self.options.btnPlay).addClass('paused');
						self.videoObj[0].play();
						$(self.options.playBtn).hide();
						setTimeout(function(){
							self.videoPlay();
						},200);
					}else if(self.videoObj[0].currentTime == 0){
						self.videoObj[0].volume = 0;
						$(self.options.btnPlay).addClass('paused');
						self.videoObj[0].play();
						$(self.options.playBtn).hide();
					}
				},videoPlay:function(){

					self.videoObj[0].play();
					//todo if(justep.Browser.isIOS){
						//减小声音
						self.videoObj[0].volume = 1;
						$(self.options.btnPlay).removeClass('paused');
						self.videoObj[0].pause();
						//$(self.options.playBtn).show();
					//}else{
						
					//}

				}
		};
