//命名空间定义
var ZebDev = zebra.namespace("ZebDevdexterity");
var mainZebDevPanel, zebDevNotiHandler, zebDevGlobal, onRecordPop, zebPlayingMedia;
ZebDev("happymusic").homework = zebra.Class([
    function (readonly, notiHandler) {
        var that = this;
        zebDevGlobal = this;
        if (typeof notiHandler == 'function') {
            zebDevNotiHandler = notiHandler;
        }
        else {
            zebDevNotiHandler = function (msg) { alert(msg); };
        }
        //是否只读
        that.readonly = readonly;
        //画布创建
        var w = window.innerWidth;
        var h = window.innerHeight * 0.75;
        
        that.Position = {};
        that.Position.w = w;
        that.Position.h = h;
        
        that.canvas = new zebra.ui.zCanvas(w, h);
        that.canvas.setStyles({ bottom: 0, position: 'absolute', opacity: 0 });
        var root = that.canvas.root;
        //创建主panel
        mainZebDevPanel = new zebra.ui.Panel();
        mainZebDevPanel.setBounds(0, 0, w, h);
        //mainZebDevPanel.setBackground("#E8E8EC");
        mainZebDevPanel.mouseDragStarted = function (e) {
            if (that.readonly == true) {
                return;
            }
            if (that.paintingCircle
                && (that.zebraCompList.length > 0 ? that.zebraCompList[that.zebraCompList.length - 1].instance : {}) != that.paintingCircle) {
                that.paintingCircle.removeMe();
                that.txtBtn.removeMe();
                that.recordBtn.removeMe();
                that.goodBtn.removeMe();
            }
            //隐藏所有展开的tag
            if (that.zebraCompList) {
                for (var i = 0; i < that.zebraCompList.length; i++) {
                    if (that.zebraCompList[i].tag.config.contentType == ZebDev.shape.popupType.text ||
                        that.zebraCompList[i].tag.config.contentType == ZebDev.shape.popupType.zan) {
                        that.zebraCompList[i].tag.instance.proto.hideContent();
                    }
                }
            }
            //记录起点坐标
            that.dragStartPt = {
                x: e.absX,
                y: that.dragCount == 0 ? e.absY - window.innerHeight * 0.25 : e.absY
            };
            that.dragCount++;
            that.paintingCircle = (new ZebDev.shape.circle(that.dragStartPt.x, that.dragStartPt.y, 1, 1)).toZebraComp();
            mainZebDevPanel.add(that.paintingCircle);
        };
        mainZebDevPanel.mouseDragEnded = function (e) {
            if (that.readonly == true) {
                return;
            }
            that.paintingCircle.setSize(that.circleParam.xAxis, that.circleParam.yAxis);
            that.paintingCircle.setLocation(that.circleParam.x, that.circleParam.y);
            //生成操作按钮
            //中间按钮坐标，直径
            var diameter = w * 0.1;
            var midBtnX = that.circleParam.x + that.circleParam.xAxis / 2 - diameter / 2;
            var midBtnY = that.circleParam.y - diameter - 10;
            //左右越界调整
            if (midBtnX - diameter - 5 < 0) {
                midBtnX = diameter + 5;
            }
            if (midBtnX + diameter * 2 + 5 > w) {
                midBtnX = w - diameter * 2 - 5;
            }
            //上越界调整
            if (midBtnY + diameter <= 0) {
                midBtnY = 0 - diameter + 1;
            }

            //文本输入
            that.txtBtn = new ZebDev.shape.button(midBtnX - diameter - 5, midBtnY, diameter, '#007ACC', '文本',
                function (e) {
                    var pop = new ZebDev.shape.popup(ZebDev.shape.popupType.text, function (inputText) {
                        //移除按钮
                        that.txtBtn.removeMe();
                        that.recordBtn.removeMe();
                        that.goodBtn.removeMe();

                        var tagConfig = {
                            left: midBtnX,
                            top: midBtnY + 10 * 2 / 3,
                            diameter: diameter * 2 / 3,
                            content: inputText,
                            contentType: ZebDev.shape.popupType.text
                        }
                        var tag = new ZebDev.shape.tag(tagConfig.left, tagConfig.top, tagConfig.diameter, tagConfig.content, tagConfig.contentType).toZebraComp();
                        mainZebDevPanel.add(tag);

                        //将内容插入到组件列表
                        that.zebraCompList.push({
                            instance: that.paintingCircle,
                            type: ZebDev.shape.compType.circle,
                            config: that.circleParam,
                            content: inputText,
                            tag: {
                                instance: tag,
                                config: tagConfig
                            }
                        });
                    });
                    pop.pop();
                }).toZebraComp();
            //语音输入
            that.recordBtn = new ZebDev.shape.button(midBtnX, midBtnY, diameter, 'green', '语音',
                function (e) {
                    if (onRecordPop && typeof (onRecordPop) == 'function') {
                        onRecordPop();
                    }
                    var pop = new ZebDev.shape.popup(ZebDev.shape.popupType.record, function (recordSrcUrl) {
                        //移除按钮
                        that.txtBtn.removeMe();
                        that.recordBtn.removeMe();
                        that.goodBtn.removeMe();

                        var tagConfig = {
                            left: midBtnX,
                            top: midBtnY + 10 * 2 / 3,
                            diameter: diameter * 2 / 3,
                            content: recordSrcUrl,
                            contentType: ZebDev.shape.popupType.record
                        }
                        var tag = new ZebDev.shape.tag(tagConfig.left, tagConfig.top, tagConfig.diameter, tagConfig.content, tagConfig.contentType).toZebraComp();
                        mainZebDevPanel.add(tag);

                        //将内容插入到组件列表
                        that.zebraCompList.push({
                            instance: that.paintingCircle,
                            type: ZebDev.shape.compType.circle,
                            config: that.circleParam,
                            content: recordSrcUrl,
                            tag: {
                                instance: tag,
                                config: tagConfig
                            }
                        });
                    });
                    pop.pop();
                }).toZebraComp();
            //表扬
            that.goodBtn = new ZebDev.shape.button(midBtnX + diameter + 5, midBtnY, diameter, 'red', '赞',
                function () {
                    //移除按钮
                    that.txtBtn.removeMe();
                    that.recordBtn.removeMe();
                    that.goodBtn.removeMe();

                    var zanText = "这里很不错！";

                    var tagConfig = {
                        left: midBtnX,
                        top: midBtnY + 10 * 2 / 3,
                        diameter: diameter * 2 / 3,
                        content: zanText,
                        contentType: ZebDev.shape.popupType.zan
                    }
                    var tag = new ZebDev.shape.tag(tagConfig.left, tagConfig.top, tagConfig.diameter, tagConfig.content, tagConfig.contentType).toZebraComp();
                    mainZebDevPanel.add(tag);

                    //将内容插入到组件列表
                    that.zebraCompList.push({
                        instance: that.paintingCircle,
                        type: ZebDev.shape.compType.circle,
                        config: that.circleParam,
                        content: zanText,
                        tag: {
                            instance: tag,
                            config: tagConfig
                        }
                    });
                }).toZebraComp();
            mainZebDevPanel.add(that.txtBtn);
            mainZebDevPanel.add(that.recordBtn);
            mainZebDevPanel.add(that.goodBtn);

            that.dragStartPt = null;
            that.curPt = null;
        };
        mainZebDevPanel.mouseDragged = function (e) {
            if (that.readonly == true) {
                return;
            }
            //当前坐标点
            that.curPt = { x: e.absX, y: e.absY };
            that.circleParam = {};
            //x坐标比较
            if (that.curPt.x > that.dragStartPt.x) {
                that.circleParam.xAxis = that.curPt.x - that.dragStartPt.x;
                that.circleParam.x = that.dragStartPt.x;
            }
            else if (that.curPt.x < that.dragStartPt.x) {
                that.circleParam.xAxis = that.dragStartPt.x - that.curPt.x;
                that.circleParam.x = that.curPt.x;
            }
            else {
                that.circleParam.xAxis = 1;
                that.circleParam.x = that.curPt.x;
            }
            //y坐标比较
            if (that.curPt.y > that.dragStartPt.y) {
                that.circleParam.yAxis = that.curPt.y - that.dragStartPt.y;
                that.circleParam.y = that.dragStartPt.y;
            }
            else if (that.curPt.y < that.dragStartPt.y) {
                that.circleParam.yAxis = that.dragStartPt.y - that.curPt.y;
                that.circleParam.y = that.curPt.y;
            }
            else {
                that.circleParam.yAxis = 1;
                that.circleParam.y = that.curPt.y;
            }
            that.paintingCircle.setSize(that.circleParam.xAxis, that.circleParam.yAxis);
            that.paintingCircle.setLocation(that.circleParam.x, that.circleParam.y);
        };
        mainZebDevPanel.mouseClicked = function (e) {
            if (that.paintingCircle
                && (that.zebraCompList.length > 0 ? that.zebraCompList[that.zebraCompList.length - 1].instance : {}) != that.paintingCircle) {
                that.paintingCircle.removeMe();
                that.txtBtn.removeMe();
                that.recordBtn.removeMe();
                that.goodBtn.removeMe();
            }
        };
        root.add(mainZebDevPanel);
        //zebra组件组
        that.zebraCompList = [];
        //drag次数，应对框架bug：第一次获取坐标不准
        that.dragCount = 0;
    },

    //获取已添加的zebra组件列表
    function getZebraCompList() {
        //移除实例的组件一览
        var resultList = [];
        if (this.zebraCompList) {
            for (var i = 0; i < this.zebraCompList.length; i++) {
                resultList.push({
                	Position:this.Position,
                    type: this.zebraCompList[i].type,
                    config: this.zebraCompList[i].config,
                    content: this.zebraCompList[i].content,
                    tag: {
                        config: this.zebraCompList[i].tag.config
                    }
                })
            }
        }
        return resultList;
    },

    //通过组件列表在画布上还原zebra组件
    function reducteCompList(zebraCompList) {
        this.zebraCompList = [];
        for (var i = 0; i < zebraCompList.length; i++) {
        	var curComp = this.clone(zebraCompList[i]);
            curComp =  this.checkConfig(curComp);
            switch (curComp.type) {
                //圆
                case ZebDev.shape.compType.circle:
                    var circle, tag;
                    if (curComp.instance) {
                        circle = curComp.instance;
                    }
                    else {
                        circle = (new ZebDev.shape.circle(curComp.config.x, curComp.config.y, curComp.config.xAxis, curComp.config.yAxis)).toZebraComp();
                    }
                    if (curComp.tag && curComp.tag.instance) {
                        tag = curComp.tag.instance;
                    }
                    else {
                        tag = new ZebDev.shape.tag(curComp.tag.config.left, curComp.tag.config.top,
                            curComp.tag.config.diameter, curComp.tag.config.content, curComp.tag.config.contentType).toZebraComp();
                    }
                    mainZebDevPanel.add(circle);
                    mainZebDevPanel.add(tag);
                    //还原组件一览（带上实例）
                    this.zebraCompList.push({
                        instance: circle,
                        type: ZebDev.shape.compType.circle,
                        config: curComp.config,
                        content: curComp.content,
                        tag: {
                            instance: tag,
                            config: curComp.tag.config
                        }
                    });
                    break;
            }
        }
    },function checkConfig(obj){
    	var Cposition = obj.Position;
    	if(typeof Cposition == "undefined" || (this.Position.w == Cposition.w && this.Position.h ==  Cposition.h)){
    		return obj;
    	};
    	if(this.Position.w != Cposition.w){//宽度不等
    		obj.config.x = obj.config.x*(this.Position.w/Cposition.w);
    		obj.config.xAxis = obj.config.xAxis*(this.Position.w/Cposition.w);
    		obj.tag.config.left = obj.tag.config.left*(this.Position.w/Cposition.w);
    	}
    	
    	if(this.Position.h != Cposition.h){
    		obj.config.y = obj.config.y*(this.Position.h/Cposition.h);
    		obj.config.yAxis = obj.config.yAxis*(this.Position.h/Cposition.h);
    		obj.tag.config.top = obj.tag.config.top*(this.Position.h/Cposition.h);
    	}
    	
    	return obj;

    },function clone(obj) {
        // Handle the 3 simple types, and null or undefined
        if (null == obj || "object" != typeof obj) return obj;

        // Handle Date
        if (obj instanceof Date) {
            var copy = new Date();
            copy.setTime(obj.getTime());
            return copy;
        }

        // Handle Array
        if (obj instanceof Array) {
            var copy = [];
            var len = obj.length;
            for (var i = 0;i < len; ++i) {
                copy[i] = clone(obj[i]);
            }
            return copy;
        }

        // Handle Object
        if (obj instanceof Object) {
            var copy = {};
            for (var attr in obj) {
                if (obj.hasOwnProperty(attr)) copy[attr] = clone(obj[attr]);
            }
            return copy;
        }

        throw new Error("Unable to copy obj! Its type isn't supported.");
    },

    //清空画布
    function clearCanvas() {
        this.zebraCompList = [];
        mainZebDevPanel.removeAll();
    },

    //设置一个值，表示当前画布是否只读
    function setReadOnly(isReadOnly) {
        if (isReadOnly == true) {
            this.readonly = true;
        }
        else if (isReadOnly == false) {
            this.readonly = false;
        }
    },

    function remove() {
        mainZebDevPanel.removeAll();
        this.canvas.root.removeMe();
        $(".zebcanvas").remove();
    },

    //隐藏
    function hideThis() {
        this.canvas.setVisible(false);
    },

    //显示
    function showThis() {
        this.canvas.setVisible(true);
    },

    function stopPlay(){
        if (zebPlayingMedia) {
            zebPlayingMedia.stop();
        }
    },

    function $clazz() {
        //操作系统类型判断
        this.isIos = function () {
            var u = navigator.userAgent;
            return !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
        };

        //将录音上传至七牛
        this.uploadRecord = function (qntoken, zebraCompListArray, finishCallback, qnUrlHead) {
            //if (typeof callback == 'function') {
            //    callback(zebraCompListArray);
            //    return;
            //}

            if (zebraCompListArray.length > 0) {
                //上传方法定义（上传一个文件）
                var gotFS, gotFileEntry;
                var uploadHandler = function (filename, completeCallback, progressCallback) {
                    gotFS = function (fileSystem) {
                        fileSystem.root.getFile(filename, {
                            create: true,
                            exclusive: false
                        }, gotFileEntry, function () { });
                    };
                    gotFileEntry = function (fileEntry) {
                        debugger;
                        qiniu.upload(qntoken, fileEntry.toURL(), function (res) {
                            if (typeof completeCallback == 'function') {
                                completeCallback(res);
                            }
                        }, function (res) {
                            if (typeof progressCallback == 'function') {
                                progressCallback(res);
                            }
                        });
                    };
                    window.requestFileSystem(LocalFileSystem.TEMPORARY, 0, gotFS, function () { });
                };

                //上传元素的位置列表
                var itemCoords = [];
                //过滤出待传文件的i，j坐标
                for (var i = 0; i < zebraCompListArray.length; i++) {
                    for (var j = 0; j < zebraCompListArray[i].length; j++) {
                        if (zebraCompListArray[i][j].tag.config.contentType == ZebDev.shape.popupType.record) {
                            itemCoords.push({ i: i, j: j });
                        }
                    }
                }
                //上传总数
                var total = itemCoords.length;

                if (total == 0 && typeof finishCallback == 'function') {
                    finishCallback(zebraCompListArray);
                    return;
                }

                //上传全部完成
                var uploadComplete = function () {
                    refreshProgressBar(total, total, 100);
                    if (typeof finishCallback == 'function') {
                        setTimeout(function () {
                            finishCallback(zebraCompListArray);
                        }, 100);
                    }
                };

                //上传进度
                var uploadProgress = function (percent) {
                    refreshProgressBar(total - itemCoords.length, total, Math.floor(percent * 100));
                };

                var doUpload = function (completeCallback, progressCallback) {
                    if (itemCoords.length > 0) {
                        var itemCoord = itemCoords.shift();
                        var item = zebraCompListArray[itemCoord.i][itemCoord.j];
                        uploadHandler(item.content,
                        function (res) {
                            if (typeof progressCallback == 'function') {
                                progressCallback(1);
                            }
                            //将音频本地路径更新为云端路径
                            if (qnUrlHead) {
                                item.content = qnUrlHead + res.key;
                                item.tag.config.content = qnUrlHead + res.key;
                            }
                            else {
                                item.content = res.key;
                            }
                            //上传下一个
                            doUpload(completeCallback, progressCallback);
                        }, function (res) {
                            progressCallback(res.percent);
                        });
                    }
                    else {
                        if (typeof completeCallback == 'function') {
                            completeCallback();
                        }
                    }
                };

                var showProgressBar = function () {
                    var w = window.innerWidth;
                    var h = window.innerHeight;
                    //阴影
                    var shadow = document.getElementById("ZebDev_upload_progress_shadow");
                    if (!shadow) {
                        shadow = document.createElement("div");
                        shadow.id = "ZebDev_upload_progress_shadow";
                        shadow.style.zIndex = 1000;
                        shadow.style.width = "100%";
                        shadow.style.height = "100%";
                        shadow.style.top = "0";
                        shadow.style.left = "0";
                        shadow.style.position = "fixed";
                        shadow.style.opacity = "0.6";
                        shadow.style.backgroundColor = "#000000";
                        document.body.appendChild(shadow);
                    }
                    //进度框
                    var bar = document.getElementById("ZebDev_upload_progress_bar");
                    if (!bar) {
                        bar = document.createElement("div");
                        bar.id = "ZebDev_upload_progress_bar";
                        bar.style.zIndex = 1001;
                        bar.style.position = "absolute";
                        bar.style.backgroundColor = "#000000";
                        bar.style.color = "#fff";
                        bar.style.width = "40%";
                        bar.style.height = "100px";
                        bar.style.top = "20%";
                        bar.style.left = "30%";
                        bar.style.opacity = "0.8";
                        bar.style.borderRadius = "20px";
                        bar.style.textAlign = "center";
                        bar.style.fontFamily = "微软雅黑";
                        bar.innerHTML = '<div style="margin-top: 20px;">正在上传语音</div><div id="ZebDev_upload_progress_index" style="display: inline-block;margin-top: 10px;"></div><div id="ZebDev_upload_progress_percent" style="display: inline-block;margin-left: 10px;"></div>';
                        document.body.appendChild(bar);
                    }
                };

                var hideProgressBar = function () {
                    var bar = document.getElementById("ZebDev_upload_progress_bar");
                    var shadow = document.getElementById("ZebDev_upload_progress_shadow");
                    if (bar) {
                        document.body.removeChild(bar);
                    }
                    if (shadow) {
                        document.body.removeChild(shadow);
                    }
                };

                var refreshProgressBar = function (index, total, percent) {
                    var bar = document.getElementById("ZebDev_upload_progress_bar");
                    if (bar) {
                        document.getElementById("ZebDev_upload_progress_index").innerHTML = index + "/" + total;
                        document.getElementById("ZebDev_upload_progress_percent").innerHTML = percent + "%";
                    }
                    else {
                        showProgressBar();
                    }
                    if (index == total && percent == 100) {
                        hideProgressBar();
                    }
                };

                //开始上传
                doUpload(uploadComplete, uploadProgress);
            }
            else if (typeof finishCallback == 'function') {
                finishCallback(zebraCompListArray);
                return;
            }
        };

    }
]);

//图形-圆圈
ZebDev("shape").circle = zebra.Class([
    //左距，上距，x半轴长，y半轴长
    function (left, top, xAxis, yAxis) {
        this.left = left;
        this.top = top;
        this.xAxis = xAxis;
        this.yAxis = yAxis;
        this.color = 'red';
        this.borderWidth = '1px';
    },

    function toZebraComp() {
        var comp = new zebra.ui.HtmlElement('div');
        comp.setLocation(this.left, this.top);
        comp.setSize(this.xAxis, this.yAxis);
        comp.setStyles({
            border: this.color + ' ' + this.borderWidth + ' solid',
            borderRadius: '100%'
        });
        return comp;
    }
]);

//图形-操作按钮
ZebDev("shape").button = zebra.Class([
    //左距，上距，直径，背景色，文字内容，点击事件委托（可选）
    function (left, top, diameter, backgroundColor, txt, clickEvent) {
        this.left = left;
        this.top = top;
        this.diameter = diameter;
        this.backgroundColor = backgroundColor;
        this.color = '#fff';
        this.text = txt;

        if (typeof clickEvent == 'function') {
            this.clickEvent = clickEvent;
        }
    },

    function toZebraComp() {
        var comp = new zebra.ui.HtmlElement('div');
        comp.setColor(this.color);
        comp.setContent(this.text);
        comp.setStyles({
            borderRadius: '100%',
            fontSize: this.diameter / 3 + 'px',
            fontFamily: '微软雅黑',
            overflow: 'hidden',
            textAlign: 'center',
            lineHeight: this.diameter + 'px',
            backgroundColor: this.backgroundColor,
            opacity: 0.8
        });
        comp.setLocation(this.left, this.top);
        comp.setSize(this.diameter, this.diameter);
        if (this.clickEvent) {
            comp.element.addEventListener('click', this.clickEvent);
        }
        return comp;
    }
]);

//图形-标记
ZebDev("shape").tag = zebra.Class([
    //左距，上距，直径，内容，内容类型
    function (left, top, diameter, content, contentType) {
        this.left = left;
        this.top = top;
        this.diameter = diameter;
        this.content = content;
        this.contentType = contentType;
        //是否正在展示
        this.isShowing = false;
    },

    function toZebraComp() {
        var that = this;
        var comp = new zebra.ui.HtmlElement('div');
        that.comp = comp;
        comp.setStyles({
            borderRadius: '100%',
            fontSize: that.diameter / 3 + 'px',
            overflow: 'hidden',
            textAlign: 'center',
            opacity: 0.5,
            backgroundColor: "orange",
            webkitAnimation: this.contentType == ZebDev.shape.popupType.zan ? "zeb_dev_tag_ani_good 1.5s infinite linear" : "zeb_dev_tag_ani 3s infinite linear",
            lineHeight: that.diameter + 'px',
            color: '#DD00DB',
            fontSize: that.diameter * 2 / 3 + 'px',
            fontWeight: 'bolder'
        });

        var innerHtml = "";
        if (this.contentType == ZebDev.shape.popupType.text) {
            innerHtml = "<div class='Zeb_Dev_Tag_Center' style='width:" + that.diameter / 2 + "px;height:" + that.diameter / 2
                + "px;margin-left:" + that.diameter / 4 + "px;margin-top:" + that.diameter / 4 + "px;color:#fff;line-height:"
                + that.diameter / 2 + "px;text-align:center;font-weight:bolder;font-size:" + that.diameter * 2 / 3 + "px;'>!</div>";
        }
        else if (this.contentType == ZebDev.shape.popupType.zan) {
            innerHtml = "赞";
        }
        else if (this.contentType == ZebDev.shape.popupType.record) {
            if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                innerHtml = "<img style='width:100%;height:100%;' src='https://oivtg60a1.qnssl.com/zeb_dev_audio.png' />"; 
            } else {
                innerHtml = "<img style='width:100%;height:100%;' src='http://7xkpii.com2.z0.glb.qiniucdn.com/zeb_dev_audio.png' />";
            }
        }
        comp.setContent(innerHtml);
        comp.setLocation(that.left, that.top);
        comp.setSize(that.diameter, that.diameter);
        comp.element.addEventListener('click', function () { that.showContent(that); });
        //记录原型
        comp.proto = that;
        return comp;
    },

    function showContent(entity) {
        var that = entity ? entity : this;
        if (that.contentType == ZebDev.shape.popupType.text
            || that.contentType == ZebDev.shape.popupType.zan) {
            if (that.isShowing == false) {
                //隐藏所有展开的tag
                if (zebDevGlobal.zebraCompList) {
                    for (var i = 0; i < zebDevGlobal.zebraCompList.length; i++) {
                        if (zebDevGlobal.zebraCompList[i].tag.config.contentType == ZebDev.shape.popupType.text ||
                            zebDevGlobal.zebraCompList[i].tag.config.contentType == ZebDev.shape.popupType.zan) {
                            zebDevGlobal.zebraCompList[i].tag.instance.proto.hideContent();
                        }
                    }
                }
                that.tagText = (new ZebDev.shape.tagText(that.left, that.top, that.diameter, that.content,
                    function () {
                        that.hideContent();
                    },
                    function () {
                        that.tagText.removeMe();
                        this.isShowing = false;
                        var i = 0;
                        for (i = 0; i < zebDevGlobal.zebraCompList.length; i++) {
                            if (zebDevGlobal.zebraCompList[i].tag.instance == that.comp) {
                                zebDevGlobal.zebraCompList[i].instance.removeMe();
                                break;
                            }
                        }
                        zebDevGlobal.zebraCompList.splice(i, 1);
                    })).toZebraComp();
                mainZebDevPanel.add(that.tagText);
                if (typeof that.tagText.bindDel == 'function') {
                    that.tagText.bindDel();
                }
                that.comp.removeMe();
                that.isShowing = true;
            }
        }
        else if (that.contentType == ZebDev.shape.popupType.record) {
            var md = ZebDev.shape.popup.getLocalMedia(that.content);
            zebPlayingMedia = md;
            md.play();
        }
    },

    function hideContent() {
        if (this.isShowing == true) {
            mainZebDevPanel.add(this.comp);
            this.tagText.removeMe();
            this.isShowing = false;
        }
    }
]);

//图形-标记说明框
ZebDev("shape").tagText = zebra.Class([
    //左距，上距，直径，内容，点击事件委托（可选）
    function (left, top, diameter, txt, clickEvent, delFunc) {
        this.left = left;
        this.top = top;
        this.diameter = diameter;
        this.txt = txt;
        this.color = "red";

        if (typeof clickEvent == 'function') {
            this.clickEvent = clickEvent;
        }
        if (typeof delFunc == 'function') {
            this.delFunc = delFunc;
        }
    },

    function toZebraComp() {
        var comp = new zebra.ui.HtmlElement('div');
        comp.setStyles({
            fontSize: this.diameter * 3 / 5 + 'px',
            textAlign: 'left',
            fontFamily: '微软雅黑',
            overflow: 'initial'
        });
        comp.setColor(this.color);
        comp.setLocation(this.left, this.top);
        comp.setSize(this.diameter * 3);

        //非只读时添加删除按钮
        if (zebDevGlobal.readonly == true) {
            if (this.clickEvent) {
                comp.element.addEventListener('click', this.clickEvent);
            }
            comp.setContent(this.txt);
        }
        else {
            var that = this;
            var innerHtml = '<div class="zeb_dev_tagTextContent">' + that.txt + '</div><div class="zeb_dev_tagTextDel" style="position: absolute;right: -15px;top: -15px;font-size: ' + window.innerWidth / 18 + 'px;">×</div>';
            comp.setContent(innerHtml);
            comp.bindDel = function () {
                if (that.clickEvent) {
                    $('.zeb_dev_tagTextContent').bind('click', that.clickEvent);
                }
                if (that.delFunc) {
                    $('.zeb_dev_tagTextDel').bind('click', that.delFunc);
                }
            };
        }
        return comp;
    }
]);

//图形-弹出框
ZebDev("shape").popup = zebra.Class([
    function (popupType, confirmCallback) {
        this.popupType = popupType;
        this.confirmCallback = confirmCallback;
    },

    function pop() {
        var w = window.innerWidth;
        var h = window.innerHeight;
        //阴影
        var shadow = document.getElementById("ZebDev_shape_popup_shadow");
        if (!shadow) {
            shadow = document.createElement("div");
            shadow.id = "ZebDev_shape_popup_shadow";
            shadow.style.zIndex = 499;
            shadow.style.width = "100%";
            shadow.style.height = "100%";
            shadow.style.top = "0";
            shadow.style.left = "0";
            shadow.style.position = "fixed";
            shadow.style.opacity = "0.6";
            shadow.style.backgroundColor = "#000000";
            document.body.appendChild(shadow);
        }
        //窗体
        var popWin = document.getElementById("ZebDev_shape_popup_window");
        if (!popWin) {
            popWin = document.createElement("div");
            popWin.id = "ZebDev_shape_popup_window";
            popWin.style.zIndex = 500;
            popWin.style.position = "absolute";
            popWin.style.backgroundColor = "#fff";
            popWin.style.fontFamily = "微软雅黑";
            popWin.style.width = (w * 0.6 < 250 ? 250 : w * 0.6) + 'px';
            popWin.style.height = 'auto';
            popWin.style.left = (w - parseInt(popWin.style.width)) / 2 + 'px';
            popWin.style.top = h * 0.3 + 'px';
            popWin.style.borderRadius = "10px";
            //文本输入
            if (this.popupType == ZebDev.shape.popupType.text) {
                var contentHtml = '<div class="Zeb_Dev_Pop_Title" style="font-size:' + parseInt(popWin.style.width) / 13 + 'px;">文本</div>';
                contentHtml += '<div class="Zeb_Dev_Pop_Text_Container"><textarea id="ZebDev_shape_popup_input" type="text" placeholder="最多100字..."></textarea></div>';
                contentHtml += '<div class="Zeb_Dev_Pop_Text_BtnBar">';
                contentHtml += '<div id="ZebDev_shape_popup_cancel" style="width: ' + (parseInt(popWin.style.width) / 2 - 1) + 'px;">取消</div>';
                contentHtml += '<div id="ZebDev_shape_popup_confirm">确定</div>';
                contentHtml += '</div>';
                popWin.innerHTML = contentHtml;
                document.body.appendChild(popWin);
                document.getElementById('ZebDev_shape_popup_cancel').addEventListener('click', this.close);
                var that = this;
                document.getElementById('ZebDev_shape_popup_confirm').addEventListener('click', function () {
                    if (typeof that.confirmCallback == 'function') {
                        var inputText = document.getElementById('ZebDev_shape_popup_input').value.trim();
                        if (!inputText) {
                            zebDevNotiHandler('请输入内容');
                            return;
                        }
                        else if (inputText.length >100) {
                            zebDevNotiHandler('内容不能超过100字');
                            return;
                        }
                        that.confirmCallback(inputText);
                    }
                    that.close();
                });
                // add by lujf 2016-5-11 屏蔽表情 start
                $("#ZebDev_shape_popup_input").keypress(function(event){ 
                	 if (event.which > 65535) {
                         return false;
                     }
                });
                document.getElementById("ZebDev_shape_popup_input").oninput = function () {
                    var ranges = [
                       '\ud83c[\udf00-\udfff]',
                       '\ud83d[\udc00-\ude4f]',
                       '\ud83d[\ude80-\udeff]'
                    ];
                    var content = $("#ZebDev_shape_popup_input").val().trim();
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#ZebDev_shape_popup_input").val(content);
                };
                // add by lujf 2016-5-11 屏蔽表情 end
            }
                //语音输入
            else if (this.popupType == ZebDev.shape.popupType.record) {
                var contentHtml = '<div class="Zeb_Dev_Pop_Title" style="font-size:' + parseInt(popWin.style.width) / 13 + 'px;">语音</div>';
                contentHtml += '<div class="ZebDev_shape_popup_tip"><div id="ZebDev_shape_popup_tip" style="font-size:' + parseInt(popWin.style.width) / 10 + 'px;" >00&nbsp;:&nbsp;00</div>';                
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    contentHtml += '<img id="ZebDev_shape_popup_playRecord" src="https://oivtg60a1.qnssl.com/zeb_dev_audio.png" style="display:none;height:' + parseInt(popWin.style.width) / 5 + 'px;"/></div>'; 
                } else {
                    contentHtml += '<img id="ZebDev_shape_popup_playRecord" src="http://7xkpii.com2.z0.glb.qiniucdn.com/zeb_dev_audio.png" style="display:none;height:' + parseInt(popWin.style.width) / 5 + 'px;"/></div>';
                }
                contentHtml += '<div class="Zeb_Dev_Pop_Text_BtnBar">';
                contentHtml += '<div id="ZebDev_shape_popup_rcd_cancel" style="width: ' + (parseInt(popWin.style.width) / 3 - 1) + 'px;">取消</div>';
                contentHtml += '<div id="ZebDev_shape_popup_rcd_do" style="width: ' + (parseInt(popWin.style.width) / 3 - 1) + 'px;">开始录音</div>';
                contentHtml += '<div id="ZebDev_shape_popup_rcd_confirm" style="width: ' + parseInt(popWin.style.width) / 3 + 'px;">确定</div>';
                contentHtml += '</div>';
                popWin.innerHTML = contentHtml;
                document.body.appendChild(popWin);
                var that = this;
                //0代表尚未录音，1代表正在录音，2代表结束录音
                that.recordStatus = 0;
                document.getElementById('ZebDev_shape_popup_rcd_cancel').addEventListener('click',
                    function () {
                        if (that.recordStatus == 1) {
                            clearInterval(that.slide);
                            that.recordStatus = 2;
                            //结束录音
                            that.mediaRec.stopRecord();
                            that.mediaRec.release();
                        }
                        that.close();
                    });
                //录音按钮
                document.getElementById('ZebDev_shape_popup_rcd_do').addEventListener('click', function () {
                    if (typeof that.confirmCallback == 'function') {
                        if (that.recordStatus == 0 || that.recordStatus == 2) {
                            that.recordStatus = 1;
                            document.getElementById('ZebDev_shape_popup_tip').innerHTML = "00&nbsp;:&nbsp;00";
                            document.getElementById('ZebDev_shape_popup_rcd_do').innerHTML = "结束录音";
                            document.getElementById('ZebDev_shape_popup_playRecord').style.display = "none";
                            var minites = 0;
                            var seconds = 0;
                            that.slide = setInterval(function () {
                                if (seconds >= 59) {
                                    minites++;
                                    seconds = 0;
                                }
                                else {
                                    seconds++;
                                }
                                document.getElementById('ZebDev_shape_popup_tip').innerHTML =
                                    (minites > 9 ? minites : "0" + minites) + "&nbsp:&nbsp" + (seconds > 9 ? seconds : "0" + seconds);
                            }, 1000);
                            //调用录音插件
                            that.fileName = (new Date()).getTime() + (ZebDev.happymusic.homework.isIos() ? ".wav" : ".wav");
                            that.mediaRec = new Media(that.fileName,
				                function () { },
				                function (err) {
				                    zebDevNotiHandler('录音失败：' + err);
				                }
                            );
                            //开始
                            that.mediaRec.startRecord();
                        }
                        else if (that.recordStatus == 1) {
                            clearInterval(that.slide);
                            that.recordStatus = 2;
                            document.getElementById('ZebDev_shape_popup_rcd_do').innerHTML = "重新录音";
                            document.getElementById('ZebDev_shape_popup_playRecord').style.display = "block";
                            //结束录音
                            that.mediaRec.stopRecord();
                            that.mediaRec.release();
                            //防止卡视频
                            //that.mediaRec.play();
                            //that.mediaRec.stop();
                            var tempMedia = new Media(that.fileName, function () { }, function (err) { });
                            tempMedia.play();
                            tempMedia.stop();
                        }
                    }
                });
                //确认按钮
                document.getElementById('ZebDev_shape_popup_rcd_confirm').addEventListener('click', function () {
                    if (typeof that.confirmCallback == 'function') {
                        if (that.recordStatus == 2) {
                            that.confirmCallback(that.fileName);
                            that.close();
                        }
                        else if (that.recordStatus == 1) {
                            zebDevNotiHandler('录音还未结束');
                        }
                        else {
                            zebDevNotiHandler('您还没有录音');
                        }
                    }
                });
                //播放录音按钮
                document.getElementById('ZebDev_shape_popup_playRecord').addEventListener('click', function () {
                    if (that.mediaRec) {
                        zebPlayingMedia = that.mediaRec;
                        that.mediaRec.play();
                    }
                });
            }
        }
    },

    function close() {
        var shadow = document.getElementById("ZebDev_shape_popup_shadow");
        var popWin = document.getElementById("ZebDev_shape_popup_window");
        if (popWin) {
            document.body.removeChild(popWin);
        }
        if (shadow) {
            document.body.removeChild(shadow);
        }
    },

    function $clazz() {
        this.getLocalMedia = function (filename) {
            return new Media(ZebDev.happymusic.homework.isIos() ? filename : filename,
                function () { }, function (err) { });
        }
    }
]);

//图形类型
ZebDev("shape").compType = {
    circle: 1,
    button: 2,
    tag: 3
};

//弹框类型
ZebDev("shape").popupType = {
    text: 1,
    record: 2,
    zan: 3
};


//图形-操作按钮
ZebDev("imageButton").imageButton = zebra.Class([
    //左距，上距，右边距,直径，背景色，文字内容，点击事件委托（可选）
    function (left, top, diameter, clickEvent,imgUrl) {
        this.left = left;
        this.top = top;
        this.imgUrl = imgUrl;
        this.diameter = diameter;

        if (typeof clickEvent == 'function') {
            this.clickEvent = clickEvent;
        }
    },

    function toZebraComp() {
        var comp = new zebra.ui.HtmlElement('div');

        comp.setStyles({
            borderRadius: '100%',
            fontSize: this.diameter / 3 + 'px',
            fontFamily: '微软雅黑',
            overflow: 'hidden',
            textAlign: 'center',
            lineHeight: this.diameter + 'px',
            border: 0
        });
        
        comp.setLocation(this.left, this.top);
        comp.setSize(this.diameter, this.diameter);
        innerHtml = "<img style='width:25px;height:25px;' src='" + this.imgUrl + "' />";
        comp.setContent(innerHtml);
        if (this.clickEvent) {
            comp.element.addEventListener('click', this.clickEvent);
        }
        return comp;
    }
]);